/*
* Copyright (c) 2000, 2007 IBM Corporation and others.
* All rights reserved. This program and the accompanying materials 
* are made available under the terms of the Eclipse Public License v1.0
* which is available at
* http://www.eclipse.org/legal/epl-v10.html
*/

package org.eclipse.datatools.sqltools.parsers.sql.query;

public class SQLQueryParserprs implements lpg.lpgjavaruntime.ParseTable, SQLQueryParsersym {

    public interface IsKeyword {
        public final static byte isKeyword[] = {0,
            0,0,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            0,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,0,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,0,0,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0
        };
    };
    public final static byte isKeyword[] = IsKeyword.isKeyword;
    public final boolean isKeyword(int index) { return isKeyword[index] != 0; }

    public interface BaseCheck {
        public final static short baseCheck[] = {0,
            1,3,2,1,1,1,1,1,1,4,
            4,4,6,6,2,1,3,1,3,1,
            3,4,1,1,1,2,3,4,4,5,
            4,1,2,4,1,2,6,1,1,1,
            1,1,1,1,3,1,4,1,1,2,
            2,1,1,1,1,1,1,1,1,1,
            1,2,5,2,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,4,1,
            1,2,1,1,1,4,4,4,6,6,
            6,1,1,1,1,1,5,3,7,1,
            1,4,4,5,5,4,1,5,3,7,
            3,7,1,4,4,1,5,1,1,1,
            0,1,1,1,1,1,1,1,1,5,
            1,3,1,1,1,1,1,1,1,1,
            4,3,3,1,1,3,0,3,3,1,
            1,1,1,1,1,1,1,2,2,1,
            1,3,3,3,3,2,1,1,1,3,
            5,6,1,1,1,5,1,3,3,1,
            1,1,3,1,1,1,3,1,1,1,
            6,5,4,3,8,7,3,1,1,3,
            6,5,6,5,1,1,5,4,4,3,
            1,0,1,1,1,0,1,0,2,0,
            1,1,0,2,0,3,0,2,0,2,
            0,1,0,3,5,5,0,2,0,1,
            2,2,2,0,1,0,2,2,0,3,
            0,2,0,1,0,3,0,2,0,3,
            1,3,1,1,2,2,1,3,5,3,
            1,2,1,2,1,2,1,1,2,8,
            2,1,1,3,2,1,1,1,1,1,
            1,1,1,3,3,1,1,3,1,3,
            1,1,1,1,1,1,1,1,1,1,
            1,4,1,4,1,4,1,1,1,2,
            1,1,1,1,1,3,4,4,2,1,
            1,3,3,1,1,3,1,2,6,4,
            2,1,1,3,9,4,5,1,3,1,
            3,1,3,1,1,1,3,7,7,1,
            3,6,3,3,1,1,3,2,0,1,
            3,6,-112,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-73,0,
            0,-43,0,-11,-57,-2,0,0,-130,0,
            0,-69,0,0,0,0,-3,0,0,0,
            0,0,0,0,-18,0,-137,0,0,0,
            0,0,0,0,-148,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -5,0,0,-110,0,-22,-67,-47,0,0,
            0,0,0,0,0,0,0,0,-12,0,
            0,0,0,-102,0,0,0,0,0,0,
            0,0,0,-8,0,0,-68,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-56,0,0,0,0,0,0,0,
            0,0,-26,0,0,-88,0,0,0,0,
            -13,0,0,0,0,0,0,0,0,0,
            -133,0,0,-15,0,0,0,0,0,-89,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-119,0,-4,0,0,
            0,-269,-19,0,0,0,0,0,-233,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-113,0,-39,0,0,-20,0,-72,0,
            0,0,-273,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-120,
            -10,0,0,0,0,-124,0,0,0,0,
            0,-74,0,0,0,0,0,0,0,0,
            0,-139,-46,0,-55,0,0,0,-75,0,
            0,0,-128,0,0,-314,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-90,-125,-14,0,0,-179,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-21,0,-58,
            0,0,0,0,0,0,0,0,-162,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-24,0,-214,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-138,-149,0,
            -163,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-23,0,-25,0,
            -53,0,0,0,0,0,-158,0,0,0,
            0,0,0,0,0,0,0,0,0,-109,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-91,0,0,0,
            0,0,0,0,0,-180,0,0,-28,0,
            0,0,0,-169,0,0,-274,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-186,-154,0,-358,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-219,-259,0,0,
            0,0,0,-145,0,0,0,-38,0,-9,
            0,0,-98,0,0,-183,0,-185,-176,0,
            0,0,0,0,-31,-177,0,0,0,0,
            0,-236,0,0,0,0,-305,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-33,0,0,0,0,0,0,0,
            0,0,0,-51,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-117,0,
            -45,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-241,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-271,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-93,0,
            -161,-34,0,0,0,0,0,0,-181,0,
            -35,0,0,0,0,-36,0,-351,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-210,-64,-37,0,-313,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-224,0,0,0,-100,0,-266,
            0,-220,0,0,0,-40,-232,-327,0,0,
            0,-275,0,0,0,-221,-41,-42,0,0,
            -80,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-331,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-187,0,-44,0,-235,0,0,-222,
            0,0,0,-280,0,0,-281,-284,0,-237,
            -238,-297,0,-303,0,-298,0,-239,0,-340,
            0,0,0,-349,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-328,0,-341,0,
            -48,-342,-49,0,0,0,-360,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-50,-52,-59,0,-136,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-61,-62,-63,
            0,0,0,-346,-70,-71,0,-82,-83,0,
            -332,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-84,0,-85,0,
            -86,-87,-92,-94,0,-333,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-96,0,-6,0,-99,-101,-182,0,0,
            -103,0,-104,-105,-106,0,-108,-111,-114,-115,
            0,-116,-121,-122,0,0,0,0,0,0,
            0,-123,0,-131,-134,-135,0,0,-140,-143,
            0,0,-144,-146,-151,0,-362,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-152,-153,-17,0,-27,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-155,-159,0,0,0,-164,-165,
            -167,0,0,0,-168,-170,-171,-172,0,0,
            -66,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-216,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-174,0,0,-175,0,-29,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-268,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-178,0,
            0,-188,0,-335,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-189,
            -190,-191,0,-192,-193,0,-194,0,-195,0,
            -81,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-196,-197,-198,-199,
            -200,-201,0,-202,-203,-204,-205,-206,0,-16,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-32,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-54,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-60,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-207,0,0,-95,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-208,-211,-213,0,-215,-223,0,-97,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-225,-227,0,-228,
            -229,-230,-234,-242,-243,0,-166,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-244,-245,0,-246,0,-247,-248,-249,
            -250,-251,-252,-253,-254,-255,0,-30,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-256,0,-257,-258,-260,-261,-262,-263,-265,
            -267,-270,-272,-276,0,-76,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -279,-282,0,-209,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-127,
            -283,-285,-286,0,-315,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-287,0,-288,-289,-290,0,-291,
            -292,-293,-294,0,0,-347,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-295,0,0,-352,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -296,-299,-300,0,-302,-304,-306,-307,-308,-309,
            0,-77,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-310,0,-65,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-129,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-173,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-107,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-118,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-311,-312,-316,
            -317,-318,-319,-320,-321,-322,0,-323,-324,-325,
            -326,-329,-330,-334,-336,-337,-338,0,-339,-343,
            -344,-345,-348,-350,-353,-354,-355,-356,-357,0,
            -126,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-132,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-147,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-156,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-157,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -160,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-212,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-217,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-218,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-226,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -231,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-264,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-301,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-78,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-79,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-141,0,0,-184,
            0,0,-361,0,0,0,-1,0,0,0,
            -7,0,0,-142,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-150,
            0,0,0,0,0,-240,-277,0,-278,0,
            -359,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0
        };
    };
    public final static short baseCheck[] = BaseCheck.baseCheck;
    public final int baseCheck(int index) { return baseCheck[index]; }
    public final static short rhs[] = baseCheck;
    public final int rhs(int index) { return rhs[index]; };

    public interface BaseAction {
        public final static char baseAction[] = {
            91,91,91,91,62,63,63,63,63,92,
            25,25,25,25,25,40,43,43,41,41,
            37,37,37,68,68,38,38,38,38,7,
            7,70,93,93,71,94,94,8,95,95,
            96,96,5,72,100,100,6,6,52,9,
            9,9,9,9,9,9,9,98,98,98,
            103,103,104,104,105,101,101,101,101,101,
            101,113,112,112,108,108,114,114,115,115,
            115,115,115,116,116,116,116,116,116,116,
            116,116,117,117,117,117,111,111,111,111,
            109,109,109,109,109,109,109,109,109,109,
            109,109,109,110,110,110,110,110,44,44,
            44,44,102,141,141,141,141,141,141,141,
            67,142,142,99,59,59,59,59,59,59,
            59,28,15,15,15,20,20,51,51,10,
            10,10,10,10,10,10,10,10,10,10,
            10,10,14,14,14,14,14,14,143,144,
            144,13,13,45,45,19,77,119,119,78,
            78,53,120,120,79,79,121,121,1,1,
            97,30,30,30,30,30,30,80,80,123,
            123,65,65,31,31,106,106,32,32,33,
            33,122,75,75,75,26,26,125,125,73,
            73,126,126,126,69,69,82,82,145,145,
            81,81,76,76,127,127,127,127,128,128,
            54,54,54,54,54,61,61,129,129,129,
            130,130,4,4,83,83,124,124,58,58,
            84,131,131,12,12,132,85,85,85,85,
            34,39,39,39,39,39,39,29,29,17,
            22,64,21,21,21,23,56,56,56,56,
            56,56,107,107,35,36,2,118,118,133,
            133,27,27,27,27,27,27,27,27,11,
            11,11,11,11,11,11,11,11,11,11,
            11,11,11,11,11,11,3,46,46,46,
            42,87,87,55,55,60,60,16,47,48,
            49,49,49,49,49,49,50,50,134,134,
            74,74,57,57,136,86,137,88,88,88,
            138,138,66,24,89,89,135,135,18,18,
            139,139,90,9845,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,825,9887,
            1228,1274,9830,1333,9651,9909,9649,444,308,10198,
            25,307,9712,306,303,305,304,742,302,301,
            18,1289,202,1274,1292,9727,1334,9812,1026,1006,
            707,989,46,351,1315,9908,1026,1006,150,858,
            46,152,156,157,153,167,151,154,155,392,
            825,9846,1228,1274,1535,1333,9619,9621,9743,444,
            308,166,25,307,448,306,303,305,304,752,
            302,301,18,1289,5185,9,1292,747,1583,270,
            282,283,707,35,9823,1293,1315,9750,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,572,9718,1026,1006,929,989,46,1253,
            729,444,308,9920,25,307,9614,306,303,305,
            304,41,302,301,18,1289,1285,33,1292,625,
            1290,9765,1026,1006,10086,989,46,1253,260,1287,
            9750,1026,1006,150,858,46,152,156,157,153,
            167,151,154,155,392,572,5185,42,5185,511,
            459,47,10308,778,444,308,15,25,307,10263,
            306,303,305,304,352,302,301,18,1289,1228,
            1274,1292,9730,1290,6661,296,1006,9910,579,5185,
            265,360,258,9750,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,572,1337,
            9737,5185,511,459,281,394,9833,444,308,361,
            25,307,9919,306,303,305,304,352,302,301,
            18,1289,9792,9831,1292,10117,1290,395,2001,9887,
            652,1254,399,5185,43,238,10057,1026,1006,150,
            858,46,152,156,157,153,167,151,154,155,
            392,572,10117,9870,5185,511,459,10234,446,1194,
            444,308,448,25,307,166,306,303,305,304,
            352,302,301,18,1289,1617,1439,1292,9985,1290,
            9812,1026,1006,130,989,46,350,280,339,9750,
            1026,1006,150,858,46,152,156,157,153,167,
            151,154,155,392,572,45,320,5185,337,9939,
            362,503,166,444,308,1302,25,307,243,306,
            303,305,304,219,302,301,18,1289,9796,10210,
            1607,9750,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,572,9762,1294,5185,
            337,5185,43,294,1272,444,308,10212,25,307,
            194,306,303,305,304,353,302,301,19,1289,
            9844,1026,1006,150,858,46,152,156,157,153,
            167,151,154,155,392,572,876,9812,1026,1006,
            208,989,46,350,444,308,10234,26,307,1497,
            306,303,305,304,9956,302,301,9976,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1790,44,9910,9674,1889,9915,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1907,448,1228,1274,173,10257,7439,334,
            193,1251,184,174,8137,1497,1461,242,5185,1226,
            9642,1304,335,2233,511,1310,9677,1888,9958,2233,
            511,1310,181,174,1225,10168,10226,474,1274,2174,
            182,2001,5185,1674,185,2174,186,9984,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1276,1,1228,1274,338,448,278,282,
            283,342,622,343,5185,337,623,342,1057,343,
            1439,277,2,4,5,6,7,8,1787,10072,
            577,9742,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,1247,2163,1228,1274,
            1460,1229,1498,41,1781,57,58,59,60,61,
            8875,298,65,66,67,68,69,70,74,75,
            76,77,133,10041,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,1611,5185,
            337,9891,9669,1786,278,282,283,728,1359,10234,
            36,9672,1124,559,371,1225,9680,277,10053,1026,
            1006,150,858,46,152,156,157,153,167,151,
            154,155,392,1790,9966,9776,9703,173,9992,1026,
            1006,150,858,46,152,156,157,153,167,151,
            154,155,392,1907,10122,1228,1274,330,7399,337,
            9939,464,10258,181,174,12,10176,9925,8138,21,
            241,180,9868,448,1313,217,10258,10177,10178,11,
            331,5923,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,606,177,9981,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1790,5185,337,749,173,4447,511,1310,
            10258,1439,22,10,9892,1906,1439,9892,9892,2196,
            9974,9982,10258,2174,9996,14,10258,1919,10264,13,
            9892,207,184,174,10000,1026,1006,150,858,46,
            152,156,157,153,167,151,154,155,392,1907,
            266,1228,1274,330,464,342,1062,343,1891,448,
            448,1892,1893,448,185,63,187,10258,824,9892,
            196,743,9892,10114,1916,346,331,10069,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1790,10181,9836,9618,173,9931,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1247,1917,1228,1274,1918,1406,9708,9710,
            9786,1906,181,174,10258,9855,10180,195,10182,10183,
            180,10365,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,1790,9826,1403,10184,
            330,9694,2973,9937,3710,178,10365,1026,1006,150,
            858,46,152,156,157,153,167,151,154,155,
            392,1790,9774,334,9743,330,9872,5924,9671,296,
            1006,10009,882,10187,10088,10186,335,10193,10197,10205,
            9957,1913,10199,10206,10207,278,282,283,334,278,
            282,283,10209,415,9808,3730,10098,1120,277,10202,
            10037,335,277,10044,10105,10211,1914,9613,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1790,4449,10070,9743,173,757,1218,1219,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1025,1220,10108,10023,278,282,283,10213,
            10018,10214,181,174,623,10119,10063,10045,10133,277,
            183,2972,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,1284,9742,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1611,10222,1228,1274,5206,1670,5923,1026,
            1006,150,858,46,152,156,157,153,159,151,
            154,155,299,9742,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,1611,10231,
            1228,1274,6662,1785,10377,1026,1006,150,858,46,
            152,156,157,153,167,151,154,155,392,1790,
            10233,10064,10236,330,10238,10239,1281,10240,39,10241,
            1195,5923,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,653,334,10244,10245,10025,
            10028,10246,10248,190,10249,10251,10256,9952,10094,336,
            9890,1026,1006,150,858,46,152,156,157,153,
            167,151,154,155,392,1105,5186,1026,1006,150,
            858,46,152,156,157,153,167,151,154,155,
            392,402,753,1026,1006,150,858,46,152,156,
            157,153,167,151,154,155,392,506,9742,1026,
            1006,150,858,46,152,156,157,153,167,151,
            154,155,392,1276,10139,1228,1274,10185,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1306,10095,10112,7400,32,10034,10142,366,
            1495,1218,1219,150,858,46,152,156,157,153,
            167,151,154,155,392,1025,1220,10261,10269,447,
            6682,10148,10259,10262,10265,10268,261,2254,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1611,10270,10271,799,10272,1610,10273,10276,
            10282,10277,10287,10292,10293,10294,10295,199,5923,1026,
            1006,150,858,46,152,156,157,153,158,151,
            154,155,10300,1252,10301,10302,10303,9704,10046,10304,
            10305,10049,10151,10059,10309,300,5923,1026,1006,150,
            858,46,152,156,157,153,165,151,154,155,
            1305,10311,10314,1608,5925,1026,1006,150,858,46,
            152,156,157,153,167,151,154,155,392,1611,
            9743,10315,10316,10318,1406,2254,1026,1006,150,858,
            46,152,156,157,153,167,151,154,155,392,
            1611,278,282,283,10310,1610,10319,10321,10320,804,
            10323,10124,10125,10154,277,1666,9993,1026,1006,150,
            858,46,152,156,157,153,167,151,154,155,
            392,1276,10325,1228,1274,8139,1026,1006,150,858,
            46,152,156,157,153,167,151,154,155,392,
            1790,10327,10073,10155,330,10332,10338,5963,10328,10329,
            10160,1909,5923,1026,1006,150,858,46,152,156,
            157,153,164,151,154,155,10334,332,10179,1026,
            1006,150,858,46,152,156,157,153,167,151,
            154,155,392,1105,753,1026,1006,150,858,46,
            152,156,157,153,167,151,154,155,392,506,
            10215,1026,1006,150,858,46,152,156,157,153,
            167,151,154,155,392,1306,753,1026,1006,150,
            858,46,152,156,157,153,167,151,154,155,
            392,1314,753,1026,1006,150,858,46,152,156,
            157,153,167,151,154,155,392,1360,9641,10158,
            10330,10341,10342,10345,10339,10352,10347,367,10354,10348,
            10357,10364,10367,10163,10376,10166,10167,10083,262,10381,
            10383,10385,10386,10170,10171,10387,10388,10391,10392,10173,
            200,753,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,1365,753,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1368,753,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,1564,753,
            1026,1006,150,858,46,152,156,157,153,167,
            151,154,155,392,709,753,1026,1006,150,858,
            46,152,156,157,153,167,151,154,155,392,
            1587,10011,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,1588,753,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1668,753,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,1050,753,
            1026,1006,150,858,46,152,156,157,153,167,
            151,154,155,392,1671,753,1026,1006,150,858,
            46,152,156,157,153,167,151,154,155,392,
            1672,753,1026,1006,150,858,46,152,156,157,
            153,167,151,154,155,392,1673,753,1026,1006,
            150,858,46,152,156,157,153,167,151,154,
            155,392,1783,753,1026,1006,150,858,46,152,
            156,157,153,167,151,154,155,392,1903,5923,
            1026,1006,150,858,46,152,156,157,153,163,
            151,154,155,5923,1026,1006,150,858,46,152,
            156,157,153,162,151,154,155,2971,511,1310,
            3709,511,1310,10174,2770,2770,2770,9784,2770,2770,
            2770,5185,337,2174,9617,2770,2174,2770,278,282,
            283,278,282,283,474,1274,868,577,2770,1121,
            9743,277,2770,2770,277,2770,9617,10264,2770,9631,
            464,10390,2770,2770,2770,342,866,343,342,866,
            343,278,282,283,824,2770,2770,2770,2770,1024,
            2770,254,464,464,277,464,2770,464,2770,1,
            4,5,6,7,8,2770,824,824,2770,824,
            2770,824,2770,254,347,2770,346,2770,345,2770,
            2770,2770,2770,2770,2770,2770,2770,341,396,2770,
            2770,370,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,340,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            553,2770,0,2985,216,0,220,216,0,2984,
            212,0,2983,212,0,2959,253,0,2958,253,
            0,2931,2958,253,0,2930,2958,253,0,875,
            2958,253,0,1516,2958,253,0,992,2958,253,
            0,1001,2958,253,0,3095,2958,253,0,3094,
            2958,253,0,3093,2958,253,0,3092,2958,253,
            0,3091,2958,253,0,574,2958,253,0,3089,
            2958,253,0,3088,2958,253,0,3087,2958,253,
            0,1056,2958,253,0,1067,2958,253,0,1068,
            2958,253,0,3080,2958,253,0,3079,2958,253,
            0,257,680,0,253,2959,0,253,2958,0,
            2931,253,2958,0,2930,253,2958,0,875,253,
            2958,0,1516,253,2958,0,992,253,2958,0,
            1001,253,2958,0,3095,253,2958,0,3094,253,
            2958,0,3093,253,2958,0,3092,253,2958,0,
            3091,253,2958,0,574,253,2958,0,3089,253,
            2958,0,3088,253,2958,0,3087,253,2958,0,
            1056,253,2958,0,1067,253,2958,0,1068,253,
            2958,0,3080,253,2958,0,3079,253,2958,0,
            477,2958,253,0,53,54,0,1792,144,0,
            2910,144,0,2909,144,0,2908,144,0,2907,
            144,0,2906,144,0,2905,144,0,2904,144,
            0,1548,369,0,2171,2958,253,0,369,2958,
            253,0,1567,369,0,296,337,0,218,216,
            0,1283,2958,253,0,770,2958,253,0,1288,
            2958,253,0,145,2919,0,1309,2958,0,252,
            2959,0,252,2958,0,161,211,0,373,369,
            0,1792,143,0,2910,143,0,2909,143,0,
            2908,143,0,2907,143,0,2906,143,0,2905,
            143,0,2904,143,0,1792,142,0,2910,142,
            0,2909,142,0,2908,142,0,2907,142,0,
            2906,142,0,2905,142,0,2904,142,0,524,
            2958,0,1500,2958,0,255,216,0,2841,2958,
            0,2843,2958,0,2842,2958,0,1462,2958,0,
            1464,2958,0,1465,2958,0,1467,2958,0,1469,
            2958,0,1487,2958,0,1488,2958,0,1489,2958,
            0,1490,2958,0,2865,2958,0,2864,2958,0,
            2863,2958,0,2862,2958,0,1491,2958,0,1492,
            2958,0,1494,2958,0,1495,2958,0,2850,2958,
            0,1496,2958,0,1052,2958,253,0,1066,2958,
            253,0,1110,2958,253,0,524,2958,253,0,
            1500,2958,253,0,122,297,0,1667,363,0,
            148,1782,0,1788,2958,253,0,1789,2958,253,
            0,1806,2958,253,0,284,216,0,887,369,
            0,369,524,2958,253,0,369,1500,2958,253,
            0,330,173,0,175,2919,0,1746,369,0
        };
    };
    public final static char baseAction[] = BaseAction.baseAction;
    public final int baseAction(int index) { return baseAction[index]; }
    public final static char lhs[] = baseAction;
    public final int lhs(int index) { return lhs[index]; };

    public interface TermCheck0 {
        public final static char termCheck0[] = {0,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            0,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,101,102,103,104,105,106,107,108,109,
            110,111,112,113,114,115,116,117,118,119,
            120,121,122,123,124,125,126,127,128,129,
            130,131,132,133,134,135,136,137,138,139,
            140,141,142,143,144,145,146,147,148,149,
            150,151,152,153,154,155,156,157,158,159,
            160,161,162,163,164,165,166,167,168,169,
            170,171,172,173,174,175,176,177,178,179,
            180,181,182,183,184,185,186,187,188,189,
            190,191,192,193,194,195,196,197,198,199,
            200,201,202,203,204,205,206,207,208,209,
            210,211,212,213,214,215,216,217,218,219,
            220,221,222,223,224,225,226,227,228,229,
            230,231,232,233,234,235,236,237,238,239,
            240,241,242,243,244,245,246,247,248,249,
            250,251,252,253,254,255,256,257,258,259,
            260,261,262,263,264,265,266,267,268,269,
            270,271,272,273,274,275,276,277,278,279,
            280,281,282,283,284,285,286,287,288,289,
            290,291,292,293,294,295,296,297,298,299,
            300,301,302,303,304,305,306,307,308,309,
            310,311,312,313,314,315,316,317,318,319,
            320,321,322,323,324,325,326,327,328,329,
            330,331,332,333,334,335,336,337,338,339,
            340,341,342,343,344,345,346,347,348,349,
            350,351,352,353,354,355,356,357,358,359,
            360,361,362,363,364,365,366,367,368,369,
            370,371,372,373,374,375,376,377,378,379,
            380,381,382,383,384,385,386,387,388,389,
            390,391,392,393,394,395,396,397,398,399,
            400,401,402,403,404,405,406,407,408,409,
            410,411,412,413,414,415,416,417,418,419,
            420,421,422,423,424,425,426,427,428,429,
            430,431,432,433,434,435,436,437,438,439,
            440,441,442,443,444,445,446,447,448,449,
            450,451,452,453,454,455,456,457,458,459,
            460,461,462,463,464,465,466,467,468,469,
            470,471,472,473,474,475,476,477,478,479,
            480,481,482,483,484,485,486,487,488,489,
            490,491,492,493,494,495,496,497,498,499,
            500,501,502,503,504,505,506,507,508,509,
            510,511,512,513,514,515,516,517,518,519,
            520,521,522,523,524,525,526,527,528,529,
            530,531,532,533,534,535,536,537,538,539,
            540,541,542,543,544,545,546,547,548,549,
            550,551,552,553,554,555,556,557,558,559,
            560,561,562,563,564,565,566,567,568,569,
            570,571,572,573,574,575,576,577,578,579,
            580,581,582,583,584,585,586,587,588,589,
            590,591,592,593,594,595,596,597,598,599,
            600,601,602,603,604,605,606,607,608,609,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,648,649,
            650,651,652,653,654,655,656,657,658,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,675,676,677,678,679,
            680,681,682,683,684,685,686,687,688,689,
            690,691,692,693,694,695,696,697,698,699,
            700,701,702,703,704,705,706,707,708,709,
            710,711,712,713,714,715,716,717,718,719,
            720,721,722,723,724,725,726,727,728,729,
            730,731,732,733,734,735,736,737,738,739,
            740,0,0,743,744,745,746,747,0,1,
            2,0,0,753,754,755,0,15,17,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,0,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,756,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,100,101,102,103,
            104,105,106,107,108,109,110,111,112,113,
            114,115,116,117,118,119,120,121,122,123,
            124,125,126,127,128,129,130,131,132,133,
            134,135,136,137,138,139,140,141,142,143,
            144,145,146,147,148,149,150,151,152,153,
            154,155,156,157,158,159,160,161,162,163,
            164,165,166,167,168,169,170,171,172,173,
            174,175,176,177,178,179,180,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            194,195,196,197,198,199,200,201,202,203,
            204,205,206,207,208,209,210,211,212,213,
            214,215,216,217,218,219,220,221,222,223,
            224,225,226,227,228,229,230,231,232,233,
            234,235,236,237,238,239,240,241,242,243,
            244,245,246,247,248,249,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,267,268,269,270,271,272,273,
            274,275,276,277,278,279,280,281,282,283,
            284,285,286,287,288,289,290,291,292,293,
            294,295,296,297,298,299,300,301,302,303,
            304,305,306,307,308,309,310,311,312,313,
            314,315,316,317,318,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            334,335,336,337,338,339,340,341,342,343,
            344,345,346,347,348,349,350,351,352,353,
            354,355,356,357,358,359,360,361,362,363,
            364,365,366,367,368,369,370,371,372,373,
            374,375,376,377,378,379,380,381,382,383,
            384,385,386,387,388,389,390,391,392,393,
            394,395,396,397,398,399,400,401,402,403,
            404,405,406,407,408,409,410,411,412,413,
            414,415,416,417,418,419,420,421,422,423,
            424,425,426,427,428,429,430,431,432,433,
            434,435,436,437,438,439,440,441,442,443,
            444,445,446,447,448,449,450,451,452,453,
            454,455,456,457,458,459,460,461,462,463,
            464,465,466,467,468,469,470,471,472,473,
            474,475,476,477,478,479,480,481,482,483,
            484,485,486,487,488,489,490,491,492,493,
            494,495,496,497,498,499,500,501,502,503,
            504,505,506,507,508,509,510,511,512,513,
            514,515,516,517,518,519,520,521,522,523,
            524,525,526,527,528,529,530,531,532,533,
            534,535,536,537,538,539,540,541,542,543,
            544,545,546,547,548,549,550,551,552,553,
            554,555,556,557,558,559,560,561,562,563,
            564,565,566,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,585,586,587,588,589,590,591,592,593,
            594,595,596,597,598,599,600,601,602,603,
            604,605,606,607,608,609,610,611,612,613,
            614,615,616,617,618,619,620,621,622,623,
            624,625,626,627,628,629,630,631,632,633,
            634,635,636,637,638,639,640,641,642,643,
            644,645,646,647,648,649,650,651,652,653,
            654,655,656,657,658,659,660,661,662,663,
            664,665,666,667,668,669,670,671,672,673,
            674,675,676,677,678,679,680,681,682,683,
            684,685,686,687,688,689,690,691,692,693,
            694,695,696,697,698,699,700,701,702,703,
            704,705,706,707,708,709,710,711,712,713,
            714,715,716,717,718,719,720,721,722,723,
            724,725,726,727,728,729,730,731,732,733,
            734,735,736,737,0,739,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,738,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,0,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,100,101,102,103,104,105,
            106,107,108,109,110,111,112,113,114,115,
            116,117,118,119,120,121,122,123,124,125,
            126,127,128,129,130,131,132,133,134,135,
            136,137,138,139,140,141,142,143,144,145,
            146,147,148,149,150,151,152,153,154,155,
            156,157,158,159,160,161,162,163,164,165,
            166,167,168,169,170,171,172,173,174,175,
            176,177,178,179,180,181,182,183,184,185,
            186,187,188,189,190,191,192,193,194,195,
            196,197,198,199,200,201,202,203,204,205,
            206,207,208,209,210,211,212,213,214,215,
            216,217,218,219,220,221,222,223,224,225,
            226,227,228,229,230,231,232,233,234,235,
            236,237,238,239,240,241,242,243,244,245,
            246,247,248,249,250,251,252,253,254,255,
            256,257,258,259,260,261,262,263,264,265,
            266,267,268,269,270,271,272,273,274,275,
            276,277,278,279,280,281,282,283,284,285,
            286,287,288,289,290,291,292,293,294,295,
            296,297,298,299,300,301,302,303,304,305,
            306,307,308,309,310,311,312,313,314,315,
            316,317,318,319,320,321,322,323,324,325,
            326,327,328,329,330,331,332,333,334,335,
            336,337,338,339,340,341,342,343,344,345,
            346,347,348,349,350,351,352,353,354,355,
            356,357,358,359,360,361,362,363,364,365,
            366,367,368,369,370,371,372,373,374,375,
            376,377,378,379,380,381,382,383,384,385,
            386,387,388,389,390,391,392,393,394,395,
            396,397,398,399,400,401,402,403,404,405,
            406,407,408,409,410,411,412,413,414,415,
            416,417,418,419,420,421,422,423,424,425,
            426,427,428,429,430,431,432,433,434,435,
            436,437,438,439,440,441,442,443,444,445,
            446,447,448,449,450,451,452,453,454,455,
            456,457,458,459,460,461,462,463,464,465,
            466,467,468,469,470,471,472,473,474,475,
            476,477,478,479,480,481,482,483,484,485,
            486,487,488,489,490,491,492,493,494,495,
            496,497,498,499,500,501,502,503,504,505,
            506,507,508,509,510,511,512,513,514,515,
            516,517,518,519,520,521,522,523,524,525,
            526,527,528,529,530,531,532,533,534,535,
            536,537,538,539,540,541,542,543,544,545,
            546,547,548,549,550,551,552,553,554,555,
            556,557,558,559,560,561,562,563,564,565,
            566,567,568,569,570,571,572,573,574,575,
            576,577,578,579,580,581,582,583,584,585,
            586,587,588,589,590,591,592,593,594,595,
            596,597,598,599,600,601,602,603,604,605,
            606,607,608,609,610,611,612,613,614,615,
            616,617,618,619,620,621,622,623,624,625,
            626,627,628,629,630,631,632,633,634,635,
            636,637,638,639,640,641,642,643,644,645,
            646,647,648,649,650,651,652,653,654,655,
            656,657,658,659,660,661,662,663,664,665,
            666,667,668,669,670,671,672,673,674,675,
            676,677,678,679,680,681,682,683,684,685,
            686,687,688,689,690,691,692,693,694,695,
            696,697,698,699,700,701,702,703,704,705,
            706,707,708,709,710,711,712,713,714,715,
            716,717,718,719,720,721,722,723,724,725,
            726,727,728,729,730,731,732,733,734,735,
            736,737,0,739,738,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,0,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,100,101,102,103,104,105,106,107,
            108,109,110,111,112,113,114,115,116,117,
            118,119,120,121,122,123,124,125,126,127,
            128,129,130,131,132,133,134,135,136,137,
            138,139,140,141,142,143,144,145,146,147,
            148,149,150,151,152,153,154,155,156,157,
            158,159,160,161,162,163,164,165,166,167,
            168,169,170,171,172,173,174,175,176,177,
            178,179,180,181,182,183,184,185,186,187,
            188,189,190,191,192,193,194,195,196,197,
            198,199,200,201,202,203,204,205,206,207,
            208,209,210,211,212,213,214,215,216,217,
            218,219,220,221,222,223,224,225,226,227,
            228,229,230,231,232,233,234,235,236,237,
            238,239,240,241,242,243,244,245,246,247,
            248,249,250,251,252,253,254,255,256,257,
            258,259,260,261,262,263,264,265,266,267,
            268,269,270,271,272,273,274,275,276,277,
            278,279,280,281,282,283,284,285,286,287,
            288,289,290,291,292,293,294,295,296,297,
            298,299,300,301,302,303,304,305,306,307,
            308,309,310,311,312,313,314,315,316,317,
            318,319,320,321,322,323,324,325,326,327,
            328,329,330,331,332,333,334,335,336,337,
            338,339,340,341,342,343,344,345,346,347,
            348,349,350,351,352,353,354,355,356,357,
            358,359,360,361,362,363,364,365,366,367,
            368,369,370,371,372,373,374,375,376,377,
            378,379,380,381,382,383,384,385,386,387,
            388,389,390,391,392,393,394,395,396,397,
            398,399,400,401,402,403,404,405,406,407,
            408,409,410,411,412,413,414,415,416,417,
            418,419,420,421,422,423,424,425,426,427,
            428,429,430,431,432,433,434,435,436,437,
            438,439,440,441,442,443,444,445,446,447,
            448,449,450,451,452,453,454,455,456,457,
            458,459,460,461,462,463,464,465,466,467,
            468,469,470,471,472,473,474,475,476,477,
            478,479,480,481,482,483,484,485,486,487,
            488,489,490,491,492,493,494,495,496,497,
            498,499,500,501,502,503,504,505,506,507,
            508,509,510,511,512,513,514,515,516,517,
            518,519,520,521,522,523,524,525,526,527,
            528,529,530,531,532,533,534,535,536,537,
            538,539,540,541,542,543,544,545,546,547,
            548,549,550,551,552,553,554,555,556,557,
            558,559,560,561,562,563,564,565,566,567,
            568,569,570,571,572,573,574,575,576,577,
            578,579,580,581,582,583,584,585,586,587,
            588,589,590,591,592,593,594,595,596,597,
            598,599,600,601,602,603,604,605,606,607,
            608,609,610,611,612,613,614,615,616,617,
            618,619,620,621,622,623,624,625,626,627,
            628,629,630,631,632,633,634,635,636,637,
            638,639,640,641,642,643,644,645,646,647,
            648,649,650,651,652,653,654,655,656,657,
            658,659,660,661,662,663,664,665,666,667,
            668,669,670,671,672,673,674,675,676,677,
            678,679,680,681,682,683,684,685,686,687,
            688,689,690,691,692,693,694,695,696,697,
            698,699,700,701,702,703,704,705,706,707,
            708,709,710,711,712,713,714,715,716,717,
            718,719,720,721,722,723,724,725,726,727,
            728,729,730,731,732,733,734,735,736,737,
            0,0,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,20,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,101,102,103,104,105,106,107,108,109,
            110,111,112,113,114,115,116,117,118,119,
            120,121,122,123,124,125,126,127,128,129,
            130,131,132,133,134,135,136,137,138,139,
            140,141,142,143,144,145,146,147,148,149,
            150,151,152,153,154,155,156,157,158,159,
            160,161,162,163,164,165,166,167,168,169,
            170,171,172,173,174,175,176,177,178,179,
            180,181,182,183,184,185,186,187,188,189,
            190,191,192,193,194,195,196,197,198,199,
            200,201,202,203,204,205,206,207,208,209,
            210,211,212,213,214,215,216,217,218,219,
            220,221,222,223,224,225,226,227,228,229,
            230,231,232,233,234,235,236,237,238,239,
            240,241,242,243,244,245,246,247,248,249,
            250,251,252,253,254,255,256,257,258,259,
            260,261,262,263,264,265,266,267,268,269,
            270,271,272,273,274,275,276,277,278,279,
            280,281,282,283,284,285,286,287,288,289,
            290,291,292,293,294,295,296,297,298,299,
            300,301,302,303,304,305,306,307,308,309,
            310,311,312,313,314,315,316,317,318,319,
            320,321,322,323,324,325,326,327,328,329,
            330,331,332,333,334,335,336,337,338,339,
            340,341,342,343,344,345,346,347,348,349,
            350,351,352,353,354,355,356,357,358,359,
            360,361,362,363,364,365,366,367,368,369,
            370,371,372,373,374,375,376,377,378,379,
            380,381,382,383,384,385,386,387,388,389,
            390,391,392,393,394,395,396,397,398,399,
            400,401,402,403,404,405,406,407,408,409,
            410,411,412,413,414,415,416,417,418,419,
            420,421,422,423,424,425,426,427,428,429,
            430,431,432,433,434,435,436,437,438,439,
            440,441,442,443,444,445,446,447,448,449,
            450,451,452,453,454,455,456,457,458,459,
            460,461,462,463,464,465,466,467,468,469,
            470,471,472,473,474,475,476,477,478,479,
            480,481,482,483,484,485,486,487,488,489,
            490,491,492,493,494,495,496,497,498,499,
            500,501,502,503,504,505,506,507,508,509,
            510,511,512,513,514,515,516,517,518,519,
            520,521,522,523,524,525,526,527,528,529,
            530,531,532,533,534,535,536,537,538,539,
            540,541,542,543,544,545,546,547,548,549,
            550,551,552,553,554,555,556,557,558,559,
            560,561,562,563,564,565,566,567,568,569,
            570,571,572,573,574,575,576,577,578,579,
            580,581,582,583,584,585,586,587,588,589,
            590,591,592,593,594,595,596,597,598,599,
            600,601,602,603,604,605,606,607,608,609,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,648,649,
            650,651,652,653,654,655,656,657,658,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,675,676,677,678,679,
            680,681,682,683,684,685,686,687,688,689,
            690,691,692,693,694,695,696,697,698,699,
            700,701,702,703,704,705,706,707,708,709,
            710,711,712,713,714,715,716,717,718,719,
            720,721,722,723,724,725,726,727,728,729,
            730,731,732,733,734,735,736,737,0,0,
            738,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,0,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,74,75,76,77,78,79,80,81,
            82,83,84,85,86,87,88,89,90,91,
            92,93,94,95,96,97,98,99,100,101,
            102,103,104,105,106,107,108,109,110,111,
            112,113,114,115,116,117,118,119,120,121,
            122,123,124,125,126,127,128,129,130,131,
            132,133,134,135,136,137,138,139,140,141,
            142,143,144,145,146,147,148,149,150,151,
            152,153,154,155,156,157,158,159,160,161,
            162,163,164,165,166,167,168,169,170,171,
            172,173,174,175,176,177,178,179,180,181,
            182,183,184,185,186,187,188,189,190,191,
            192,193,194,195,196,197,198,199,200,201,
            202,203,204,205,206,207,208,209,210,211,
            212,213,214,215,216,217,218,219,220,221,
            222,223,224,225,226,227,228,229,230,231,
            232,233,234,235,236,237,238,239,240,241,
            242,243,244,245,246,247,248,249,250,251,
            252,253,254,255,256,257,258,259,260,261,
            262,263,264,265,266,267,268,269,270,271,
            272,273,274,275,276,277,278,279,280,281,
            282,283,284,285,286,287,288,289,290,291,
            292,293,294,295,296,297,298,299,300,301,
            302,303,304,305,306,307,308,309,310,311,
            312,313,314,315,316,317,318,319,320,321,
            322,323,324,325,326,327,328,329,330,331,
            332,333,334,335,336,337,338,339,340,341,
            342,343,344,345,346,347,348,349,350,351,
            352,353,354,355,356,357,358,359,360,361,
            362,363,364,365,366,367,368,369,370,371,
            372,373,374,375,376,377,378,379,380,381,
            382,383,384,385,386,387,388,389,390,391,
            392,393,394,395,396,397,398,399,400,401,
            402,403,404,405,406,407,408,409,410,411,
            412,413,414,415,416,417,418,419,420,421,
            422,423,424,425,426,427,428,429,430,431,
            432,433,434,435,436,437,438,439,440,441,
            442,443,444,445,446,447,448,449,450,451,
            452,453,454,455,456,457,458,459,460,461,
            462,463,464,465,466,467,468,469,470,471,
            472,473,474,475,476,477,478,479,480,481,
            482,483,484,485,486,487,488,489,490,491,
            492,493,494,495,496,497,498,499,500,501,
            502,503,504,505,506,507,508,509,510,511,
            512,513,514,515,516,517,518,519,520,521,
            522,523,524,525,526,527,528,529,530,531,
            532,533,534,535,536,537,538,539,540,541,
            542,543,544,545,546,547,548,549,550,551,
            552,553,554,555,556,557,558,559,560,561,
            562,563,564,565,566,567,568,569,570,571,
            572,573,574,575,576,577,578,579,580,581,
            582,583,584,585,586,587,588,589,590,591,
            592,593,594,595,596,597,598,599,600,601,
            602,603,604,605,606,607,608,609,610,611,
            612,613,614,615,616,617,618,619,620,621,
            622,623,624,625,626,627,628,629,630,631,
            632,633,634,635,636,637,638,639,640,641,
            642,643,644,645,646,647,648,649,650,651,
            652,653,654,655,656,657,658,659,660,661,
            662,663,664,665,666,667,668,669,670,671,
            672,673,674,675,676,677,678,679,680,681,
            682,683,684,685,686,687,688,689,690,691,
            692,693,694,695,696,697,698,699,700,701,
            702,703,704,705,706,707,708,709,710,711,
            712,713,714,715,716,717,718,719,720,721,
            722,723,724,725,726,727,728,729,730,731,
            732,733,734,735,736,737,0,738,0,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,738,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,100,101,102,103,
            104,105,106,107,108,109,110,111,112,113,
            114,115,116,117,118,119,120,121,122,123,
            124,125,126,127,128,129,130,131,132,133,
            134,135,136,137,138,139,140,141,142,143,
            144,145,146,147,148,149,150,151,152,153,
            154,155,156,157,158,159,160,161,162,163,
            164,165,166,167,168,169,170,171,172,173,
            174,175,176,177,178,179,180,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            194,195,196,197,198,199,200,201,202,203,
            204,205,206,207,208,209,210,211,212,213,
            214,215,216,217,218,219,220,221,222,223,
            224,225,226,227,228,229,230,231,232,233,
            234,235,236,237,238,239,240,241,242,243,
            244,245,246,247,248,249,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,267,268,269,270,271,272,273,
            274,275,276,277,278,279,280,281,282,283,
            284,285,286,287,288,289,290,291,292,293,
            294,295,296,297,298,299,300,301,302,303,
            304,305,306,307,308,309,310,311,312,313,
            314,315,316,317,318,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            334,335,336,337,338,339,340,341,342,343,
            344,345,346,347,348,349,350,351,352,353,
            354,355,356,357,358,359,360,361,362,363,
            364,365,366,367,368,369,370,371,372,373,
            374,375,376,377,378,379,380,381,382,383,
            384,385,386,387,388,389,390,391,392,393,
            394,395,396,397,398,399,400,401,402,403,
            404,405,406,407,408,409,410,411,412,413,
            414,415,416,417,418,419,420,421,422,423,
            424,425,426,427,428,429,430,431,432,433,
            434,435,436,437,438,439,440,441,442,443,
            444,445,446,447,448,449,450,451,452,453,
            454,455,456,457,458,459,460,461,462,463,
            464,465,466,467,468,469,470,471,472,473,
            474,475,476,477,478,479,480,481,482,483,
            484,485,486,487,488,489,490,491,492,493,
            494,495,496,497,498,499,500,501,502,503,
            504,505,506,507,508,509,510,511,512,513,
            514,515,516,517,518,519,520,521,522,523,
            524,525,526,527,528,529,530,531,532,533,
            534,535,536,537,538,539,540,541,542,543,
            544,545,546,547,548,549,550,551,552,553,
            554,555,556,557,558,559,560,561,562,563,
            564,565,566,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,585,586,587,588,589,590,591,592,593,
            594,595,596,597,598,599,600,601,602,603,
            604,605,606,607,608,609,610,611,612,613,
            614,615,616,617,618,619,620,621,622,623,
            624,625,626,627,628,629,630,631,632,633,
            634,635,636,637,638,639,640,641,642,643,
            644,645,646,647,648,649,650,651,652,653,
            654,655,656,657,658,659,660,661,662,663,
            664,665,666,667,668,669,670,671,672,673,
            674,675,676,677,678,679,680,681,682,683,
            684,685,686,687,688,689,690,691,692,693,
            694,695,696,697,698,699,700,701,702,703,
            704,705,706,707,708,709,710,711,712,713,
            714,715,716,717,718,719,720,721,722,723,
            724,725,726,727,728,729,730,731,732,733,
            734,735,736,737,0,0,738,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,0,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,39,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,100,101,102,103,104,105,
            106,107,108,109,110,111,112,113,114,115,
            116,117,118,119,120,121,122,123,124,125,
            126,127,128,129,130,131,132,133,134,135,
            136,137,138,139,140,141,142,143,144,145,
            146,147,148,149,150,151,152,153,154,155,
            156,157,158,159,160,161,162,163,164,165,
            166,167,168,169,170,171,172,173,174,175,
            176,177,178,179,180,181,182,183,184,185,
            186,187,188,189,190,191,192,193,194,195,
            196,197,198,199,200,201,202,203,204,205,
            206,207,208,209,210,211,212,213,214,215,
            216,217,218,219,220,221,222,223,224,225,
            226,227,228,229,230,231,232,233,234,235,
            236,237,238,239,240,241,242,243,244,245,
            246,247,248,249,250,251,252,253,254,255,
            256,257,258,259,260,261,262,263,264,265,
            266,267,268,269,270,271,272,273,274,275,
            276,277,278,279,280,281,282,283,284,285,
            286,287,288,289,290,291,292,293,294,295,
            296,297,298,299,300,301,302,303,304,305,
            306,307,308,309,310,311,312,313,314,315,
            316,317,318,319,320,321,322,323,324,325,
            326,327,328,329,330,331,332,333,334,335,
            336,337,338,339,340,341,342,343,344,345,
            346,347,348,349,350,351,352,353,354,355,
            356,357,358,359,360,361,362,363,364,365,
            366,367,368,369,370,371,372,373,374,375,
            376,377,378,379,380,381,382,383,384,385,
            386,387,388,389,390,391,392,393,394,395,
            396,397,398,399,400,401,402,403,404,405,
            406,407,408,409,410,411,412,413,414,415,
            416,417,418,419,420,421,422,423,424,425,
            426,427,428,429,430,431,432,433,434,435,
            436,437,438,439,440,441,442,443,444,445,
            446,447,448,449,450,451,452,453,454,455,
            456,457,458,459,460,461,462,463,464,465,
            466,467,468,469,470,471,472,473,474,475,
            476,477,478,479,480,481,482,483,484,485,
            486,487,488,489,490,491,492,493,494,495,
            496,497,498,499,500,501,502,503,504,505,
            506,507,508,509,510,511,512,513,514,515,
            516,517,518,519,520,521,522,523,524,525,
            526,527,528,529,530,531,532,533,534,535,
            536,537,538,539,540,541,542,543,544,545,
            546,547,548,549,550,551,552,553,554,555,
            556,557,558,559,560,561,562,563,564,565,
            566,567,568,569,570,571,572,573,574,575,
            576,577,578,579,580,581,582,583,584,585,
            586,587,588,589,590,591,592,593,594,595,
            596,597,598,599,600,601,602,603,604,605,
            606,607,608,609,610,611,612,613,614,615,
            616,617,618,619,620,621,622,623,624,625,
            626,627,628,629,630,631,632,633,634,635,
            636,637,638,639,640,641,642,643,644,645,
            646,647,648,649,650,651,652,653,654,655,
            656,657,658,659,660,661,662,663,664,665,
            666,667,668,669,670,671,672,673,674,675,
            676,677,678,679,680,681,682,683,684,685,
            686,687,688,689,690,691,692,693,694,695,
            696,697,698,699,700,701,702,703,704,705,
            706,707,708,709,710,711,712,713,714,715,
            716,717,718,719,720,721,722,723,724,725,
            726,727,728,729,730,731,732,733,734,735,
            736,737,0,0,0,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,738,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,0,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,100,101,102,103,104,105,106,107,
            108,109,110,111,112,113,114,115,116,117,
            118,119,120,121,122,123,124,125,126,127,
            128,129,130,131,132,133,134,135,136,137,
            138,139,140,141,142,143,144,145,146,147,
            148,149,150,151,152,153,154,155,156,157,
            158,159,160,161,162,163,164,165,166,167,
            168,169,170,171,172,173,174,175,176,177,
            178,179,180,181,182,183,184,185,186,187,
            188,189,190,191,192,193,194,195,196,197,
            198,199,200,201,202,203,204,205,206,207,
            208,209,210,211,212,213,214,215,216,217,
            218,219,220,221,222,223,224,225,226,227,
            228,229,230,231,232,233,234,235,236,237,
            238,239,240,241,242,243,244,245,246,247,
            248,249,250,251,252,253,254,255,256,257,
            258,259,260,261,262,263,264,265,266,267,
            268,269,270,271,272,273,274,275,276,277,
            278,279,280,281,282,283,284,285,286,287,
            288,289,290,291,292,293,294,295,296,297,
            298,299,300,301,302,303,304,305,306,307,
            308,309,310,311,312,313,314,315,316,317,
            318,319,320,321,322,323,324,325,326,327,
            328,329,330,331,332,333,334,335,336,337,
            338,339,340,341,342,343,344,345,346,347,
            348,349,350,351,352,353,354,355,356,357,
            358,359,360,361,362,363,364,365,366,367,
            368,369,370,371,372,373,374,375,376,377,
            378,379,380,381,382,383,384,385,386,387,
            388,389,390,391,392,393,394,395,396,397,
            398,399,400,401,402,403,404,405,406,407,
            408,409,410,411,412,413,414,415,416,417,
            418,419,420,421,422,423,424,425,426,427,
            428,429,430,431,432,433,434,435,436,437,
            438,439,440,441,442,443,444,445,446,447,
            448,449,450,451,452,453,454,455,456,457,
            458,459,460,461,462,463,464,465,466,467,
            468,469,470,471,472,473,474,475,476,477,
            478,479,480,481,482,483,484,485,486,487,
            488,489,490,491,492,493,494,495,496,497,
            498,499,500,501,502,503,504,505,506,507,
            508,509,510,511,512,513,514,515,516,517,
            518,519,520,521,522,523,524,525,526,527,
            528,529,530,531,532,533,534,535,536,537,
            538,539,540,541,542,543,544,545,546,547,
            548,549,550,551,552,553,554,555,556,557,
            558,559,560,561,562,563,564,565,566,567,
            568,569,570,571,572,573,574,575,576,577,
            578,579,580,581,582,583,584,585,586,587,
            588,589,590,591,592,593,594,595,596,597,
            598,599,600,601,602,603,604,605,606,607,
            608,609,610,611,612,613,614,615,616,617,
            618,619,620,621,622,623,624,625,626,627,
            628,629,630,631,632,633,634,635,636,637,
            638,639,640,641,642,643,644,645,646,647,
            648,649,650,651,652,653,654,655,656,657,
            658,659,660,661,662,663,664,665,666,667,
            668,669,670,671,672,673,674,675,676,677,
            678,679,680,681,682,683,684,685,686,687,
            688,689,690,691,692,693,694,695,696,697,
            698,699,700,701,702,703,704,705,706,707,
            708,709,710,711,712,713,714,715,716,717,
            718,719,720,721,722,723,724,725,726,727,
            728,729,730,731,732,733,734,735,736,737,
            0,0,739,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,0,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            738,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,101,102,103,104,105,106,107,108,109,
            110,111,112,113,114,115,116,117,118,119,
            120,121,122,123,124,125,126,127,128,129,
            130,131,132,133,134,135,136,137,138,139,
            140,141,142,143,144,145,146,147,148,149,
            150,151,152,153,154,155,156,157,158,159,
            160,161,162,163,164,165,166,167,168,169,
            170,171,172,173,174,175,176,177,178,179,
            180,181,182,183,184,185,186,187,188,189,
            190,191,192,193,194,195,196,197,198,199,
            200,201,202,203,204,205,206,207,208,209,
            210,211,212,213,214,215,216,217,218,219,
            220,221,222,223,224,225,226,227,228,229,
            230,231,232,233,234,235,236,237,238,239,
            240,241,242,243,244,245,246,247,248,249,
            250,251,252,253,254,255,256,257,258,259,
            260,261,262,263,264,265,266,267,268,269,
            270,271,272,273,274,275,276,277,278,279,
            280,281,282,283,284,285,286,287,288,289,
            290,291,292,293,294,295,296,297,298,299,
            300,301,302,303,304,305,306,307,308,309,
            310,311,312,313,314,315,316,317,318,319,
            320,321,322,323,324,325,326,327,328,329,
            330,331,332,333,334,335,336,337,338,339,
            340,341,342,343,344,345,346,347,348,349,
            350,351,352,353,354,355,356,357,358,359,
            360,361,362,363,364,365,366,367,368,369,
            370,371,372,373,374,375,376,377,378,379,
            380,381,382,383,384,385,386,387,388,389,
            390,391,392,393,394,395,396,397,398,399,
            400,401,402,403,404,405,406,407,408,409,
            410,411,412,413,414,415,416,417,418,419,
            420,421,422,423,424,425,426,427,428,429,
            430,431,432,433,434,435,436,437,438,439,
            440,441,442,443,444,445,446,447,448,449,
            450,451,452,453,454,455,456,457,458,459,
            460,461,462,463,464,465,466,467,468,469,
            470,471,472,473,474,475,476,477,478,479,
            480,481,482,483,484,485,486,487,488,489,
            490,491,492,493,494,495,496,497,498,499,
            500,501,502,503,504,505,506,507,508,509,
            510,511,512,513,514,515,516,517,518,519,
            520,521,522,523,524,525,526,527,528,529,
            530,531,532,533,534,535,536,537,538,539,
            540,541,542,543,544,545,546,547,548,549,
            550,551,552,553,554,555,556,557,558,559,
            560,561,562,563,564,565,566,567,568,569,
            570,571,572,573,574,575,576,577,578,579,
            580,581,582,583,584,585,586,587,588,589,
            590,591,592,593,594,595,596,597,598,599,
            600,601,602,603,604,605,606,607,608,609,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,648,649,
            650,651,652,653,654,655,656,657,658,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,675,676,677,678,679,
            680,681,682,683,684,685,686,687,688,689,
            690,691,692,693,694,695,696,697,698,699,
            700,701,702,703,704,705,706,707,708,709,
            710,711,712,713,714,715,716,717,718,719,
            720,721,722,723,724,725,726,727,728,729,
            730,731,732,733,734,735,736,737,0,0,
            739,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,20,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,0,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,74,75,76,77,78,79,80,81,
            82,83,84,85,86,87,88,89,90,91,
            92,93,94,95,96,97,98,99,100,101,
            102,103,104,105,106,107,108,109,110,111,
            112,113,114,115,116,117,118,119,120,121,
            122,123,124,125,126,127,128,129,130,131,
            132,133,134,135,136,137,138,139,140,141,
            142,143,144,145,146,147,148,149,150,151,
            152,153,154,155,156,157,158,159,160,161,
            162,163,164,165,166,167,168,169,170,171,
            172,173,174,175,176,177,178,179,180,181,
            182,183,184,185,186,187,188,189,190,191,
            192,193,194,195,196,197,198,199,200,201,
            202,203,204,205,206,207,208,209,210,211,
            212,213,214,215,216,217,218,219,220,221,
            222,223,224,225,226,227,228,229,230,231,
            232,233,234,235,236,237,238,239,240,241,
            242,243,244,245,246,247,248,249,250,251,
            252,253,254,255,256,257,258,259,260,261,
            262,263,264,265,266,267,268,269,270,271,
            272,273,274,275,276,277,278,279,280,281,
            282,283,284,285,286,287,288,289,290,291,
            292,293,294,295,296,297,298,299,300,301,
            302,303,304,305,306,307,308,309,310,311,
            312,313,314,315,316,317,318,319,320,321,
            322,323,324,325,326,327,328,329,330,331,
            332,333,334,335,336,337,338,339,340,341,
            342,343,344,345,346,347,348,349,350,351,
            352,353,354,355,356,357,358,359,360,361,
            362,363,364,365,366,367,368,369,370,371,
            372,373,374,375,376,377,378,379,380,381,
            382,383,384,385,386,387,388,389,390,391,
            392,393,394,395,396,397,398,399,400,401,
            402,403,404,405,406,407,408,409,410,411,
            412,413,414,415,416,417,418,419,420,421,
            422,423,424,425,426,427,428,429,430,431,
            432,433,434,435,436,437,438,439,440,441,
            442,443,444,445,446,447,448,449,450,451,
            452,453,454,455,456,457,458,459,460,461,
            462,463,464,465,466,467,468,469,470,471,
            472,473,474,475,476,477,478,479,480,481,
            482,483,484,485,486,487,488,489,490,491,
            492,493,494,495,496,497,498,499,500,501,
            502,503,504,505,506,507,508,509,510,511,
            512,513,514,515,516,517,518,519,520,521,
            522,523,524,525,526,527,528,529,530,531,
            532,533,534,535,536,537,538,539,540,541,
            542,543,544,545,546,547,548,549,550,551,
            552,553,554,555,556,557,558,559,560,561,
            562,563,564,565,566,567,568,569,570,571,
            572,573,574,575,576,577,578,579,580,581,
            582,583,584,585,586,587,588,589,590,591,
            592,593,594,595,596,597,598,599,600,601,
            602,603,604,605,606,607,608,609,610,611,
            612,613,614,615,616,617,618,619,620,621,
            622,623,624,625,626,627,628,629,630,631,
            632,633,634,635,636,637,638,639,640,641,
            642,643,644,645,646,647,648,649,650,651,
            652,653,654,655,656,657,658,659,660,661,
            662,663,664,665,666,667,668,669,670,671,
            672,673,674,675,676,677,678,679,680,681,
            682,683,684,685,686,687,688,689,690,691,
            692,693,694,695,696,697,698,699,700,701,
            702,703,704,705,706,707,708,709,710,711,
            712,713,714,715,716,717,718,719,720,721,
            722,723,724,725,726,727,728,729,730,731,
            732,733,734,735,736,737,0,0,0,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,0,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,0,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54
        };
    };

    public interface TermCheck1 {
        public final static char termCheck1[] = {
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,84,
            85,86,87,88,89,90,91,92,93,94,
            95,96,97,98,99,100,101,102,103,104,
            105,106,107,108,109,110,111,112,113,114,
            115,116,117,118,119,120,121,122,123,124,
            125,126,127,128,129,130,131,132,133,134,
            135,136,137,138,139,140,141,142,143,144,
            145,146,147,148,149,150,151,152,153,154,
            155,156,157,158,159,160,161,162,163,164,
            165,166,167,168,169,170,171,172,173,174,
            175,176,177,178,179,180,181,182,183,184,
            185,186,187,188,189,190,191,192,193,194,
            195,196,197,198,199,200,201,202,203,204,
            205,206,207,208,209,210,211,212,213,214,
            215,216,217,218,219,220,221,222,223,224,
            225,226,227,228,229,230,231,232,233,234,
            235,236,237,238,239,240,241,242,243,244,
            245,246,247,248,249,250,251,252,253,254,
            255,256,257,258,259,260,261,262,263,264,
            265,266,267,268,269,270,271,272,273,274,
            275,276,277,278,279,280,281,282,283,284,
            285,286,287,288,289,290,291,292,293,294,
            295,296,297,298,299,300,301,302,303,304,
            305,306,307,308,309,310,311,312,313,314,
            315,316,317,318,319,320,321,322,323,324,
            325,326,327,328,329,330,331,332,333,334,
            335,336,337,338,339,340,341,342,343,344,
            345,346,347,348,349,350,351,352,353,354,
            355,356,357,358,359,360,361,362,363,364,
            365,366,367,368,369,370,371,372,373,374,
            375,376,377,378,379,380,381,382,383,384,
            385,386,387,388,389,390,391,392,393,394,
            395,396,397,398,399,400,401,402,403,404,
            405,406,407,408,409,410,411,412,413,414,
            415,416,417,418,419,420,421,422,423,424,
            425,426,427,428,429,430,431,432,433,434,
            435,436,437,438,439,440,441,442,443,444,
            445,446,447,448,449,450,451,452,453,454,
            455,456,457,458,459,460,461,462,463,464,
            465,466,467,468,469,470,471,472,473,474,
            475,476,477,478,479,480,481,482,483,484,
            485,486,487,488,489,490,491,492,493,494,
            495,496,497,498,499,500,501,502,503,504,
            505,506,507,508,509,510,511,512,513,514,
            515,516,517,518,519,520,521,522,523,524,
            525,526,527,528,529,530,531,532,533,534,
            535,536,537,538,539,540,541,542,543,544,
            545,546,547,548,549,550,551,552,553,554,
            555,556,557,558,559,560,561,562,563,564,
            565,566,567,568,569,570,571,572,573,574,
            575,576,577,578,579,580,581,582,583,584,
            585,586,587,588,589,590,591,592,593,594,
            595,596,597,598,599,600,601,602,603,604,
            605,606,607,608,609,610,611,612,613,614,
            615,616,617,618,619,620,621,622,623,624,
            625,626,627,628,629,630,631,632,633,634,
            635,636,637,638,639,640,641,642,643,644,
            645,646,647,648,649,650,651,652,653,654,
            655,656,657,658,659,660,661,662,663,664,
            665,666,667,668,669,670,671,672,673,674,
            675,676,677,678,679,680,681,682,683,684,
            685,686,687,688,689,690,691,692,693,694,
            695,696,697,698,699,700,701,702,703,704,
            705,706,707,708,709,710,711,712,713,714,
            715,716,717,718,719,720,721,722,723,724,
            725,726,727,728,729,730,731,732,733,734,
            735,736,737,0,0,0,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,0,22,23,24,25,26,
            27,28,29,30,31,32,33,34,35,36,
            37,38,39,0,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,75,76,
            77,78,79,80,81,82,83,84,85,86,
            87,88,89,90,91,92,93,94,95,96,
            97,98,99,100,101,102,103,104,105,106,
            107,108,109,110,111,112,113,114,115,116,
            117,118,119,120,121,122,123,124,125,126,
            127,128,129,130,131,132,133,134,135,136,
            137,138,139,140,141,142,143,144,145,146,
            147,148,149,150,151,152,153,154,155,156,
            157,158,159,160,161,162,163,164,165,166,
            167,168,169,170,171,172,173,174,175,176,
            177,178,179,180,181,182,183,184,185,186,
            187,188,189,190,191,192,193,194,195,196,
            197,198,199,200,201,202,203,204,205,206,
            207,208,209,210,211,212,213,214,215,216,
            217,218,219,220,221,222,223,224,225,226,
            227,228,229,230,231,232,233,234,235,236,
            237,238,239,240,241,242,243,244,245,246,
            247,248,249,250,251,252,253,254,255,256,
            257,258,259,260,261,262,263,264,265,266,
            267,268,269,270,271,272,273,274,275,276,
            277,278,279,280,281,282,283,284,285,286,
            287,288,289,290,291,292,293,294,295,296,
            297,298,299,300,301,302,303,304,305,306,
            307,308,309,310,311,312,313,314,315,316,
            317,318,319,320,321,322,323,324,325,326,
            327,328,329,330,331,332,333,334,335,336,
            337,338,339,340,341,342,343,344,345,346,
            347,348,349,350,351,352,353,354,355,356,
            357,358,359,360,361,362,363,364,365,366,
            367,368,369,370,371,372,373,374,375,376,
            377,378,379,380,381,382,383,384,385,386,
            387,388,389,390,391,392,393,394,395,396,
            397,398,399,400,401,402,403,404,405,406,
            407,408,409,410,411,412,413,414,415,416,
            417,418,419,420,421,422,423,424,425,426,
            427,428,429,430,431,432,433,434,435,436,
            437,438,439,440,441,442,443,444,445,446,
            447,448,449,450,451,452,453,454,455,456,
            457,458,459,460,461,462,463,464,465,466,
            467,468,469,470,471,472,473,474,475,476,
            477,478,479,480,481,482,483,484,485,486,
            487,488,489,490,491,492,493,494,495,496,
            497,498,499,500,501,502,503,504,505,506,
            507,508,509,510,511,512,513,514,515,516,
            517,518,519,520,521,522,523,524,525,526,
            527,528,529,530,531,532,533,534,535,536,
            537,538,539,540,541,542,543,544,545,546,
            547,548,549,550,551,552,553,554,555,556,
            557,558,559,560,561,562,563,564,565,566,
            567,568,569,570,571,572,573,574,575,576,
            577,578,579,580,581,582,583,584,585,586,
            587,588,589,590,591,592,593,594,595,596,
            597,598,599,600,601,602,603,604,605,606,
            607,608,609,610,611,612,613,614,615,616,
            617,618,619,620,621,622,623,624,625,626,
            627,628,629,630,631,632,633,634,635,636,
            637,638,639,640,641,642,643,644,645,646,
            647,648,649,650,651,652,653,654,655,656,
            657,658,659,660,661,662,663,664,665,666,
            667,668,669,670,671,672,673,674,675,676,
            677,678,679,680,681,682,683,684,685,686,
            687,688,689,690,691,692,693,694,695,696,
            697,698,699,700,701,702,703,704,705,706,
            707,708,709,710,711,712,713,714,715,716,
            717,718,719,720,721,722,723,724,725,726,
            727,728,729,730,731,732,733,734,735,736,
            737,0,0,1,2,0,0,0,3,0,
            3,6,7,8,9,10,11,12,13,0,
            13,20,3,17,23,6,21,26,9,0,
            0,12,27,28,29,34,31,0,33,0,
            21,40,3,14,14,43,45,46,39,48,
            49,50,51,52,53,54,55,0,57,0,
            0,59,0,1,2,0,4,5,0,60,
            69,70,7,8,35,10,11,76,16,20,
            18,19,0,21,83,26,21,86,58,88,
            89,0,0,92,93,65,0,38,0,40,
            0,1,2,21,45,46,0,48,49,50,
            51,52,53,54,55,0,57,87,0,1,
            2,6,4,5,9,0,20,12,69,70,
            0,0,26,41,16,76,18,19,0,39,
            15,82,83,5,14,86,40,88,89,24,
            0,45,46,0,48,49,50,51,52,53,
            54,55,0,57,0,1,2,3,38,38,
            40,40,0,20,0,69,70,85,40,26,
            0,17,76,21,0,35,14,7,8,83,
            10,11,86,40,88,89,0,13,45,46,
            0,48,49,50,51,52,53,54,55,29,
            57,0,82,82,0,1,2,21,0,0,
            20,0,69,70,0,6,26,3,9,76,
            58,12,0,0,0,21,83,65,5,86,
            21,88,89,0,33,45,46,14,48,49,
            50,51,52,53,54,55,0,57,0,87,
            0,1,2,7,8,47,10,11,47,69,
            70,38,40,40,56,0,76,56,0,0,
            0,21,64,83,5,64,86,31,88,89,
            72,73,74,72,73,74,0,0,0,81,
            66,5,81,0,25,47,26,0,0,91,
            14,14,91,0,56,82,37,14,40,0,
            7,8,64,10,11,0,23,0,1,2,
            72,73,74,14,38,38,40,34,40,81,
            0,38,29,40,0,0,0,67,40,91,
            6,71,6,9,0,9,12,38,12,40,
            6,21,0,9,0,21,12,21,6,0,
            0,9,0,0,12,21,6,32,82,9,
            0,0,12,21,0,82,14,23,0,62,
            6,21,23,9,14,14,12,0,34,0,
            3,82,14,34,40,21,0,1,2,40,
            38,0,40,0,15,4,0,44,38,38,
            40,40,0,1,2,0,38,16,40,0,
            19,293,0,0,0,1,2,0,1,2,
            41,0,36,30,22,0,30,0,1,2,
            5,0,0,40,82,21,40,0,0,22,
            0,0,82,82,23,4,5,38,21,40,
            82,0,1,2,0,34,0,1,2,21,
            23,40,0,0,85,40,0,1,2,15,
            32,34,21,0,1,2,0,40,24,39,
            0,5,0,90,21,0,90,0,1,2,
            0,82,0,0,63,32,20,15,13,68,
            60,0,1,2,42,293,293,0,1,2,
            0,1,2,21,21,25,0,1,2,0,
            1,2,0,0,1,2,0,37,0,1,
            2,0,1,2,0,0,0,75,0,0,
            14,0,0,21,0,0,0,0,0,0,
            0,0,0,0,0,0,21,23,3,21,
            21,0,21,21,15,0,0,0,34,293,
            0,21,21,0,0,0,40,0,0,0,
            0,0,0,0,40,40,40,40,40,22,
            0,18,40,40,0,21,21,36,21,0,
            21,0,0,21,0,40,0,0,0,0,
            40,21,0,0,0,61,0,0,40,0,
            40,27,21,40,0,0,0,0,29,0,
            0,0,0,0,30,3,0,0,0,0,
            0,0,61,77,0,0,40,40,40,40,
            0,22,40,40,40,0,40,40,21,28,
            0,0,0,0,40,40,40,40,0,0,
            0,0,0,0,44,331,0,0,0,0,
            331,79,0,0,0,40,0,0,0,0,
            14,0,21,0,21,0,0,0,0,80,
            0,40,0,21,21,21,0,0,21,0,
            0,78,21,0,21,0,0,40,293,40,
            0,21,0,738,738,0,40,21,78,40,
            21,21,0,0,21,0,40,40,78,4,
            755,21,755,21,0,0,761,738,761,0,
            0,0,0,0,0,0,0,0,0,0,
            0,3,0,0,0,755,0,0,0,0,
            21,761,21,40,21,21,21,21,761,742,
            21,21,742,0,40,40,84,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            738,0,0,0,756,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,756,0,0,
            0,0,756,0,756,0,0,0,0,0,
            0,0,0,0,739,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            738,0,738,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,738,0,0,0,0,0,0,0,
            756,0,0,0,738,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,756,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,741,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,741,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,740,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,756,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,740,0,0,0,0,0,0,
            0,756,0,0,0,0,0,0,756,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,756,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            740,0,0,0,0,0,0,0,0,0,
            738,738,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            738,0,0,0,738,0,0,0,0,0,
            0,0,0,738,0,0,738,738,0,738,
            738,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,741,0,741,
            741,741,741,0,0,741,0,0,0,0,
            0,0,0,0,0,0,741,0,0,0,
            0,0,0,741,741,0,0,0,0,741,
            741,741,0,0,742,0,0,0,0,741,
            0,0,0,0,0,0,0,0,0,741,
            0,0,0,0,0,0,741,0,0,741,
            0,0,0,0,0,0,0,0,741,0,
            0,0,0,0,0,0,741,741,0,0,
            0,0,0,0,0,0,741,0,0,0,
            0,0,0,741,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0
        };
    };

    public final static char termCheck[] = new char[TermCheck0.termCheck0.length + TermCheck1.termCheck1.length];
    {
        int index = 0;
        System.arraycopy(TermCheck0.termCheck0, 0, termCheck, index, TermCheck0.termCheck0.length);
        index += TermCheck0.termCheck0.length;
        System.arraycopy(TermCheck1.termCheck1, 0, termCheck, index, TermCheck1.termCheck1.length);
    };
    public final int termCheck(int index) { return termCheck[index]; }

    public interface TermAction0 {
        public final static char termAction0[] = {0,
            26,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            11,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,2504,2504,2504,2504,2504,2504,2504,2504,2504,
            2504,3,39,2504,2504,2504,2504,2504,36,1471,
            1071,10,43,2504,2504,2504,21,3046,601,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2420,15,2417,2417,
            2417,2417,2440,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,296,2417,2417,2417,
            2417,2432,2428,2417,2496,2476,2472,2468,2492,2488,
            2464,2460,2417,2424,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2484,2480,2417,2417,2417,
            2417,2417,2436,2417,2417,2417,2417,2417,2417,2456,
            2417,2417,2452,2417,2448,2444,2417,2417,2417,2414,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,73,3037,22,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2420,914,2417,2417,2417,2417,
            2440,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,84,2417,2417,2417,2417,2432,
            2428,2417,2496,2476,2472,2468,2492,2488,2464,2460,
            2417,2424,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2484,2480,2417,2417,2417,2417,2417,
            2436,2417,2417,2417,2417,2417,2417,2456,2417,2417,
            2452,2417,2448,2444,2417,2417,2417,2414,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,74,3037,1808,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,126,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2157,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2959,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2566,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            107,54,67,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2551,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2632,2958,
            2160,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2629,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2959,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2566,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,141,70,
            1824,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,101,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2632,2958,2160,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2629,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2959,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2566,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,182,521,116,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,1840,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2157,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2959,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2566,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,4,25,2017,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,135,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2500,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2959,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,23,77,164,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2420,2081,2417,2417,2417,2417,2440,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,241,2417,2417,2417,2417,2432,2428,2417,
            2496,2476,2472,2468,2492,2488,2464,2460,2417,2424,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2484,2480,2417,2417,2417,2417,2417,2436,2417,
            2417,2417,2417,2417,2417,2456,2417,2417,2452,2417,
            2448,2444,2417,2417,2417,2414,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            31,143,3038,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,176,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            1087,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2414,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,76,167,
            3039,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2979,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,204,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2569,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,2572,2572,2572,2572,
            2572,2572,2572,2572,2572,2572,111,261,280,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2770,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2770,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958
        };
    };

    public interface TermAction1 {
        public final static char termAction1[] = {
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2959,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2674,2647,
            2958,2958,2958,2650,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2668,2671,
            2958,2958,2958,2662,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2638,2958,2958,
            2958,2653,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2686,2689,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2695,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2701,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2659,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2680,2683,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2692,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2698,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2677,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2644,2958,2641,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2665,
            2656,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,186,2770,2770,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2770,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2770,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2959,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,2958,2958,2958,2958,2958,2958,2958,2958,2958,
            2958,290,68,1471,1071,108,48,18,2313,55,
            2313,2635,2635,2635,2635,2635,2635,2635,2635,218,
            2316,2931,2313,863,1789,2745,255,1001,2745,246,
            8,2745,2635,2635,2635,1788,2635,2,2635,9,
            284,1746,2313,1905,2171,2991,1516,875,477,3079,
            3087,3088,3089,3080,1068,574,3091,27,2930,139,
            28,2992,118,1471,1071,140,757,1355,29,1856,
            1067,1056,657,3010,2316,999,796,992,1985,2328,
            1354,1969,66,2919,3092,2328,3114,3093,407,3094,
            3095,30,206,2958,2959,441,49,2720,50,1335,
            57,1471,1071,2996,2328,2328,45,2328,2328,2328,
            2328,2328,2328,2328,2328,14,2328,548,87,1471,
            1071,1171,757,1355,1173,92,2328,1193,2328,2328,
            37,6,2328,1126,1985,2328,1354,1969,56,1872,
            2322,2716,2328,2555,2534,2328,787,2328,2328,2319,
            19,2328,2328,100,2328,2328,2328,2328,2328,2328,
            2328,2328,72,2328,52,1471,1071,2313,2538,1500,
            2531,1335,1,2328,51,2328,2328,1122,373,2328,
            105,2548,2328,3026,104,493,2171,657,3010,2328,
            999,796,2328,787,2328,2328,99,530,2328,2328,
            47,2328,2328,2328,2328,2328,2328,2328,2328,244,
            2328,7,2538,524,64,1471,1071,1367,35,38,
            2328,96,2328,2328,42,1171,2328,1249,1173,2328,
            407,1193,83,86,5,2563,2328,441,2555,2328,
            3054,2328,2328,58,678,2328,2328,2534,2328,2328,
            2328,2328,2328,2328,2328,2328,216,2328,97,548,
            75,1471,1071,657,3010,2507,999,796,2581,2328,
            2328,2538,425,2578,2528,60,2328,2602,13,123,
            220,2919,2525,2328,1044,2599,2328,636,2328,2328,
            2522,2519,2516,2596,2593,2590,113,46,16,2513,
            654,2555,2587,286,2794,2605,2890,61,20,2510,
            2534,2171,2584,179,2626,2538,2793,2534,931,103,
            657,3010,2623,999,796,69,2737,168,1471,1071,
            2620,2617,2614,2534,2538,2542,2578,2733,751,2611,
            160,2538,244,2767,129,89,142,2888,2411,2608,
            1171,2889,1171,1173,165,1173,1193,2538,1193,2531,
            1171,2724,183,1173,215,3142,1193,1128,1171,264,
            184,1173,240,17,1193,2911,1171,689,2538,1173,
            248,275,1193,2197,238,2538,2534,2737,277,1669,
            1171,2199,2737,1173,2534,2534,1193,78,2733,122,
            854,2538,2534,2733,1028,3128,125,1471,1071,1746,
            2756,121,2748,153,2704,847,154,1532,2538,2538,
            2531,2531,169,1471,1071,109,2538,2049,2531,213,
            2033,2559,110,131,207,1471,1071,210,1471,1071,
            2712,279,2065,1640,2097,249,1643,214,1471,1071,
            2555,130,145,1642,2751,2730,1645,288,117,2113,
            91,235,2538,2538,2737,1167,1902,2720,148,887,
            2538,270,1471,1071,12,2733,80,1471,1071,2797,
            2737,827,161,163,2708,373,102,1471,1071,2322,
            689,2733,2764,112,1471,1071,119,827,2319,1872,
            166,1585,40,1641,2798,44,1644,128,1471,1071,
            173,2716,230,231,3017,689,2980,3044,530,3018,
            1856,132,1471,1071,848,2559,2559,162,1471,1071,
            172,1471,1071,2858,2857,2794,177,1471,1071,212,
            1471,1071,232,236,1471,1071,247,2793,244,1471,
            1071,263,1471,1071,268,269,24,2834,276,278,
            330,285,289,2856,32,33,34,53,59,41,
            62,63,65,71,81,79,3103,3005,2575,3098,
            3097,82,2946,2949,3042,85,98,90,3006,2559,
            106,3096,3134,88,93,94,1371,95,114,115,
            120,124,127,133,389,612,629,931,600,731,
            134,991,1710,1197,136,3086,3084,1953,3082,137,
            1584,144,138,2941,146,2190,147,148,149,150,
            1278,2967,151,152,155,2799,156,157,1694,158,
            1387,1613,2807,1197,159,170,171,178,1107,174,
            181,180,185,187,1614,2313,188,175,189,190,
            191,192,2800,1366,193,195,1615,1633,1634,1636,
            194,731,1638,1639,1646,196,1662,1664,2942,583,
            197,198,199,200,1665,1423,552,973,201,202,
            203,205,208,209,807,2741,211,217,225,219,
            2741,3015,221,222,223,1734,224,226,228,227,
            2171,229,3133,233,2962,234,242,243,250,2852,
            237,1738,245,2885,2884,2876,239,254,2873,251,
            252,1691,2872,253,2849,256,258,1715,2559,1890,
            255,2961,257,255,1590,259,1894,3129,1713,1896,
            2867,2887,260,265,2878,262,1231,1256,1737,1224,
            255,2875,220,2874,266,267,255,1444,220,271,
            2770,272,2770,273,274,281,282,2770,287,283,
            284,2313,2770,2770,2770,3,2770,2770,2770,2770,
            1915,3,2861,1134,2860,2859,2201,2869,2312,2821,
            2882,2880,2820,2770,1008,1134,1904,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            633,2770,2770,2770,3022,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,296,2770,2770,
            2770,2770,2545,2770,1048,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,1361,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            417,2770,218,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,869,2770,2770,2770,2770,2770,2770,2770,
            1277,2770,2770,2770,417,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,546,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,3125,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,3124,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,1937,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,296,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,1612,2770,2770,2770,2770,2770,2770,
            2770,1103,2770,2770,2770,2770,2770,2770,1442,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,960,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2727,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            1899,1900,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            1901,2770,2770,2770,2761,2770,2770,2770,2770,2770,
            2770,2770,2770,1765,2770,2770,1444,1444,2770,1177,
            1317,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,1114,2770,1117,
            1692,1711,1118,2770,2770,1712,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,1736,2770,2770,2770,
            2770,2770,2770,1740,1741,2770,2770,2770,2770,1742,
            1743,1762,2770,2770,3000,2770,2770,2770,2770,1895,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,1898,
            2770,2770,2770,2770,2770,2770,1058,2770,2770,1130,
            2770,2770,2770,2770,2770,2770,2770,2770,1169,2770,
            2770,2770,2770,2770,2770,2770,1172,1910,2770,2770,
            2770,2770,2770,2770,2770,2770,1911,2770,2770,2770,
            2770,2770,2770,1912
        };
    };

    public final static char termAction[] = new char[TermAction0.termAction0.length + TermAction1.termAction1.length];
    {
        int index = 0;
        System.arraycopy(TermAction0.termAction0, 0, termAction, index, TermAction0.termAction0.length);
        index += TermAction0.termAction0.length;
        System.arraycopy(TermAction1.termAction1, 0, termAction, index, TermAction1.termAction1.length);
    };
    public final int termAction(int index) { return termAction[index]; }

    public interface DefaultReduce {
        public final static char defaultReduce[] = {0,
            369,2770,2770,2770,2770,2770,251,369,216,2770,
            337,212,2770,279,368,227,2770,216,2770,257,
            2770,285,2770,2770,2770,2770,2770,2770,2770,42,
            2770,315,313,311,144,365,2770,2770,275,273,
            271,2770,2770,259,2770,369,2770,2770,42,2770,
            2770,216,2770,2770,225,2770,2770,2770,337,2770,
            2770,2770,2770,145,2770,2770,250,223,2770,356,
            2770,2770,2770,2770,2770,2770,2770,2770,161,38,
            2770,2770,2770,2770,2770,147,2770,20,48,16,
            225,212,2770,2770,2770,143,142,249,2770,2770,
            201,198,147,259,348,2770,2770,216,2770,2770,
            2770,224,147,2770,2770,2770,2770,145,2770,2770,
            2770,2770,2770,2770,2770,233,2770,146,2770,2770,
            2770,357,2770,2770,2770,237,2770,246,2770,244,
            2770,2770,2770,2770,2770,2770,96,116,2770,113,
            107,2770,101,100,85,84,83,81,78,122,
            40,31,2770,147,2770,363,2770,231,2770,2770,
            2770,295,2770,17,2770,232,145,2770,349,239,
            2770,2770,2770,2770,216,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,62,2770,2770,146,2770,2770,2770,
            369,34,2770,146,2770,244,2770,216,98,121,
            2770,2770,2770,111,2770,2770,109,2770,2770,2770,
            2770,2770,2770,2770,2770,204,2770,2770,2770,2770,
            234,2770,2770,175,2770,2770,173,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,203,2770,2770,2770,2770,2770,2770,175,
            2770,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,216,2770,2770,2770
        };
    };
    public final static char defaultReduce[] = DefaultReduce.defaultReduce;
    public final int defaultReduce(int index) { return defaultReduce[index]; }

    public interface ShiftState {
        public final static char shiftState[] = {0,
            4564,1508,3008,3761,4520,4565,4537,4564,4505,2260,
            1,4644,2270,4619,3024,4596,4663,1504,4669,4596,
            764,3024,2270,4596,2270,2,3763,3763,2260,1,
            3761,4596,4596,4596,4543,758,2270,4614,4667,4667,
            4667,2261,2270,3010,3023,4636,3761,4507,2260,2260,
            2260,4526,2270,2270,4627,2270,4502,2260,4596,4535,
            4535,4670,4521,4600,4596,4521,3024,4571,4546,3024,
            2270,4521,764,3023,4600,3761,3782,2261,2261,758,
            4672,4676,2270,4517,4596,2270,4593,4679,4685,4683,
            4627,4542,4670,4670,4670,4543,4543,4680,4521,3023,
            3024,758,2270,4640,4631,4596,3023,4503,2260,2260,
            3761,758,2270,4596,4670,3024,4643,4558,4518,4596,
            4633,2270,4608,4672,2255,2270,4670,758,4614,4618,
            4546,758,2270,4670,3024,3017,4589,4689,3023,743,
            3023,4614,3782,4670,2260,4692,4596,4596,4596,4596,
            4596,4596,4570,4570,4596,4596,4596,4693,4596,4670,
            4646,758,4643,2270,4614,4546,4694,4653,4656,4596,
            4596,758,4665,4683,4670,3024,758,4596,4631,4696,
            4663,3023,4614,4614,2261,3761,4698,4535,4535,4535,
            4535,4535,4535,4698,4596,4535,4698,4596,4535,4535,
            4535,4535,4535,752,4670,4586,4600,3763,4521,4656,
            4699,758,2270,758,2270,4573,4596,4555,4596,4606,
            4670,4670,4670,4596,4535,4670,4596,4535,4670,4521,
            4521,4521,4670,4535,3009,758,4521,4614,4521,2270,
            3024,4596,4596,758,4700,4648,3024,1517,2270,4535,
            4670,4670,4670,4535,4670,4535,4670,4535,4535,4535,
            744,4706,758,2270,2270,4596,2270,4661,4521,4600,
            4670,4670,4670,4670,1517,4521,2270,4521,2270,2270,
            4670,4670,4670,4670,4521,1517,2261,2270,4521,4499
        };
    };
    public final static char shiftState[] = ShiftState.shiftState;
    public final int shiftState(int index) { return shiftState[index]; }

    public interface ShiftCheck {
        public final static char shiftCheck[] = {0,
            0,0,1,2,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,0,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,76,77,78,
            79,80,81,82,83,84,85,86,87,88,
            89,90,91,92,93,94,95,96,97,98,
            99,100,101,102,103,104,105,106,107,108,
            109,110,111,112,113,114,115,116,117,118,
            119,120,121,122,123,124,125,126,127,128,
            129,130,131,132,133,134,135,136,137,138,
            139,140,141,142,143,144,145,146,147,148,
            149,150,151,152,153,154,155,156,157,158,
            159,160,161,162,163,164,165,166,167,168,
            169,170,171,172,173,174,175,176,177,178,
            179,180,181,182,183,184,185,186,187,188,
            189,190,191,192,193,194,195,196,197,198,
            199,200,201,202,203,204,205,206,207,208,
            209,210,211,212,213,214,215,216,217,218,
            219,220,221,222,223,224,225,226,227,228,
            229,230,231,232,233,234,235,236,237,238,
            239,240,241,242,243,244,245,246,247,248,
            249,250,251,252,253,254,255,256,257,258,
            259,260,261,262,263,264,265,266,267,268,
            269,270,271,272,273,274,275,276,277,278,
            279,280,281,282,283,284,285,286,287,288,
            289,290,291,292,293,294,295,296,297,298,
            299,300,301,302,303,304,305,306,307,308,
            309,310,311,312,313,314,315,316,317,318,
            319,320,321,322,323,324,325,326,327,328,
            329,330,331,332,333,334,335,336,337,338,
            339,340,341,342,343,344,345,346,347,348,
            349,350,351,352,353,354,355,356,357,358,
            359,360,361,362,363,364,365,366,367,368,
            369,370,371,372,373,374,375,376,377,378,
            379,380,381,382,383,384,385,386,387,388,
            389,390,391,392,393,394,395,396,397,398,
            399,400,401,402,403,404,405,406,407,408,
            409,410,411,412,413,414,415,416,417,418,
            419,420,421,422,423,424,425,426,427,428,
            429,430,431,432,433,434,435,436,437,438,
            439,440,441,442,443,444,445,446,447,448,
            449,450,451,452,453,454,455,456,457,458,
            459,460,461,462,463,464,465,466,467,468,
            469,470,471,472,473,474,475,476,477,478,
            479,480,481,482,483,484,485,486,487,488,
            489,490,491,492,493,494,495,496,497,498,
            499,500,501,502,503,504,505,506,507,508,
            509,510,511,512,513,514,515,516,517,518,
            519,520,521,522,523,524,525,526,527,528,
            529,530,531,532,533,534,535,536,537,538,
            539,540,541,542,543,544,545,546,547,548,
            549,550,551,552,553,554,555,556,557,558,
            559,560,561,562,563,564,565,566,567,568,
            569,570,571,572,573,574,575,576,577,578,
            579,580,581,582,583,584,585,586,587,588,
            589,590,591,592,593,594,595,596,597,598,
            599,600,601,602,603,604,605,606,607,608,
            609,610,611,612,613,614,615,616,617,618,
            619,620,621,622,623,624,625,626,627,628,
            629,630,631,632,633,634,635,636,637,638,
            639,640,641,642,643,644,645,646,647,648,
            649,650,651,652,653,654,655,656,657,658,
            659,660,661,662,663,664,665,666,667,668,
            669,670,671,672,673,674,675,676,677,678,
            679,680,681,682,683,684,685,686,687,688,
            689,690,691,692,693,694,695,696,697,698,
            699,700,701,702,703,704,705,706,707,708,
            709,710,711,712,713,714,715,716,717,718,
            719,720,721,722,723,724,725,726,727,728,
            729,730,731,732,733,734,735,736,737,738,
            739,740,0,0,743,744,745,746,747,7,
            8,0,10,11,753,754,755,0,1,2,
            0,0,761,21,1,2,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,0,22,23,24,25,26,
            27,28,29,30,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,75,76,
            77,78,79,80,81,82,83,84,85,86,
            87,88,89,90,91,92,93,94,95,96,
            97,98,99,100,101,102,103,104,105,106,
            107,108,109,110,111,112,113,114,115,116,
            117,118,119,120,121,122,123,124,125,126,
            127,128,129,130,131,132,133,134,135,136,
            137,138,139,140,141,142,143,144,145,146,
            147,148,149,150,151,152,153,154,155,156,
            157,158,159,160,161,162,163,164,165,166,
            167,168,169,170,171,172,173,174,175,176,
            177,178,179,180,181,182,183,184,185,186,
            187,188,189,190,191,192,193,194,195,196,
            197,198,199,200,201,202,203,204,205,206,
            207,208,209,210,211,212,213,214,215,216,
            217,218,219,220,221,222,223,224,225,226,
            227,228,229,230,231,232,233,234,235,236,
            237,238,239,240,241,242,243,244,245,246,
            247,248,249,250,251,252,253,254,255,256,
            257,258,259,260,261,262,263,264,265,266,
            267,268,269,270,271,272,273,274,275,276,
            277,278,279,280,281,282,283,284,285,286,
            287,288,289,290,291,292,293,294,295,296,
            297,298,299,300,301,302,303,304,305,306,
            307,308,309,310,311,312,313,314,315,316,
            317,318,319,320,321,322,323,324,325,326,
            327,328,329,330,331,332,333,334,335,336,
            337,338,339,340,341,342,343,344,345,346,
            347,348,349,350,351,352,353,354,355,356,
            357,358,359,360,361,362,363,364,365,366,
            367,368,369,370,371,372,373,374,375,376,
            377,378,379,380,381,382,383,384,385,386,
            387,388,389,390,391,392,393,394,395,396,
            397,398,399,400,401,402,403,404,405,406,
            407,408,409,410,411,412,413,414,415,416,
            417,418,419,420,421,422,423,424,425,426,
            427,428,429,430,431,432,433,434,435,436,
            437,438,439,440,441,442,443,444,445,446,
            447,448,449,450,451,452,453,454,455,456,
            457,458,459,460,461,462,463,464,465,466,
            467,468,469,470,471,472,473,474,475,476,
            477,478,479,480,481,482,483,484,485,486,
            487,488,489,490,491,492,493,494,495,496,
            497,498,499,500,501,502,503,504,505,506,
            507,508,509,510,511,512,513,514,515,516,
            517,518,519,520,521,522,523,524,525,526,
            527,528,529,530,531,532,533,534,535,536,
            537,538,539,540,541,542,543,544,545,546,
            547,548,549,550,551,552,553,554,555,556,
            557,558,559,560,561,562,563,564,565,566,
            567,568,569,570,571,572,573,574,575,576,
            577,578,579,580,581,582,583,584,585,586,
            587,588,589,590,591,592,593,594,595,596,
            597,598,599,600,601,602,603,604,605,606,
            607,608,609,610,611,612,613,614,615,616,
            617,618,619,620,621,622,623,624,625,626,
            627,628,629,630,631,632,633,634,635,636,
            637,638,639,640,641,642,643,644,645,646,
            647,648,649,650,651,652,653,654,655,656,
            657,658,659,660,661,662,663,664,665,666,
            667,668,669,670,671,672,673,674,675,676,
            677,678,679,680,681,682,683,684,685,686,
            687,688,689,690,691,692,693,694,695,696,
            697,698,699,700,701,702,703,704,705,706,
            707,708,709,710,711,712,713,714,715,716,
            717,718,719,720,721,722,723,724,725,726,
            727,728,729,730,731,732,733,734,735,736,
            737,758,739,760,741,742,3,0,757,0,
            759,748,749,750,751,752,13,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,100,101,102,103,
            104,105,106,107,108,109,110,111,112,113,
            114,115,116,117,118,119,120,121,122,123,
            124,125,126,127,128,129,130,131,132,133,
            134,135,136,137,138,139,140,141,142,143,
            144,145,146,147,148,149,150,151,152,153,
            154,155,156,157,158,159,160,161,162,163,
            164,165,166,167,168,169,170,171,172,173,
            174,175,176,177,178,179,180,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            194,195,196,197,198,199,200,201,202,203,
            204,205,206,207,208,209,210,211,212,213,
            214,215,216,217,218,219,220,221,222,223,
            224,225,226,227,228,229,230,231,232,233,
            234,235,236,237,238,239,240,241,242,243,
            244,245,246,247,248,249,250,251,252,253,
            254,255,256,257,258,259,260,261,262,263,
            264,265,266,267,268,269,270,271,272,273,
            274,275,276,277,278,279,280,281,282,283,
            284,285,286,287,288,289,290,291,292,293,
            294,295,296,297,298,299,300,301,302,303,
            304,305,306,307,308,309,310,311,312,313,
            314,315,316,317,318,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            334,335,336,337,338,339,340,341,342,343,
            344,345,346,347,348,349,350,351,352,353,
            354,355,356,357,358,359,360,361,362,363,
            364,365,366,367,368,369,370,371,372,373,
            374,375,376,377,378,379,380,381,382,383,
            384,385,386,387,388,389,390,391,392,393,
            394,395,396,397,398,399,400,401,402,403,
            404,405,406,407,408,409,410,411,412,413,
            414,415,416,417,418,419,420,421,422,423,
            424,425,426,427,428,429,430,431,432,433,
            434,435,436,437,438,439,440,441,442,443,
            444,445,446,447,448,449,450,451,452,453,
            454,455,456,457,458,459,460,461,462,463,
            464,465,466,467,468,469,470,471,472,473,
            474,475,476,477,478,479,480,481,482,483,
            484,485,486,487,488,489,490,491,492,493,
            494,495,496,497,498,499,500,501,502,503,
            504,505,506,507,508,509,510,511,512,513,
            514,515,516,517,518,519,520,521,522,523,
            524,525,526,527,528,529,530,531,532,533,
            534,535,536,537,538,539,540,541,542,543,
            544,545,546,547,548,549,550,551,552,553,
            554,555,556,557,558,559,560,561,562,563,
            564,565,566,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,585,586,587,588,589,590,591,592,593,
            594,595,596,597,598,599,600,601,602,603,
            604,605,606,607,608,609,610,611,612,613,
            614,615,616,617,618,619,620,621,622,623,
            624,625,626,627,628,629,630,631,632,633,
            634,635,636,637,638,639,640,641,642,643,
            644,645,646,647,648,649,650,651,652,653,
            654,655,656,657,658,659,660,661,662,663,
            664,665,666,667,668,669,670,671,672,673,
            674,675,676,677,678,679,680,681,682,683,
            684,685,686,687,688,689,690,691,692,693,
            694,695,696,697,698,699,700,701,702,703,
            704,705,706,707,708,709,710,711,712,713,
            714,715,716,717,718,719,720,721,722,723,
            724,725,726,727,728,729,730,731,732,733,
            734,735,736,737,0,1,2,741,742,0,
            0,0,755,3,748,749,750,751,752,0,
            1,2,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            36,22,23,24,25,26,27,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,89,90,
            91,92,93,94,95,96,97,98,99,100,
            101,102,103,104,105,106,107,108,109,110,
            111,112,113,114,115,116,117,118,119,120,
            121,122,123,124,125,126,127,128,129,130,
            131,132,133,134,135,136,137,138,139,140,
            141,142,143,144,145,146,147,148,149,150,
            151,152,153,154,155,156,157,158,159,160,
            161,162,163,164,165,166,167,168,169,170,
            171,172,173,174,175,176,177,178,179,180,
            181,182,183,184,185,186,187,188,189,190,
            191,192,193,194,195,196,197,198,199,200,
            201,202,203,204,205,206,207,208,209,210,
            211,212,213,214,215,216,217,218,219,220,
            221,222,223,224,225,226,227,228,229,230,
            231,232,233,234,235,236,237,238,239,240,
            241,242,243,244,245,246,247,248,249,250,
            251,252,253,254,255,256,257,258,259,260,
            261,262,263,264,265,266,267,268,269,270,
            271,272,273,274,275,276,277,278,279,280,
            281,282,283,284,285,286,287,288,289,290,
            291,292,293,294,295,296,297,298,299,300,
            301,302,303,304,305,306,307,308,309,310,
            311,312,313,314,315,316,317,318,319,320,
            321,322,323,324,325,326,327,328,329,330,
            331,332,333,334,335,336,337,338,339,340,
            341,342,343,344,345,346,347,348,349,350,
            351,352,353,354,355,356,357,358,359,360,
            361,362,363,364,365,366,367,368,369,370,
            371,372,373,374,375,376,377,378,379,380,
            381,382,383,384,385,386,387,388,389,390,
            391,392,393,394,395,396,397,398,399,400,
            401,402,403,404,405,406,407,408,409,410,
            411,412,413,414,415,416,417,418,419,420,
            421,422,423,424,425,426,427,428,429,430,
            431,432,433,434,435,436,437,438,439,440,
            441,442,443,444,445,446,447,448,449,450,
            451,452,453,454,455,456,457,458,459,460,
            461,462,463,464,465,466,467,468,469,470,
            471,472,473,474,475,476,477,478,479,480,
            481,482,483,484,485,486,487,488,489,490,
            491,492,493,494,495,496,497,498,499,500,
            501,502,503,504,505,506,507,508,509,510,
            511,512,513,514,515,516,517,518,519,520,
            521,522,523,524,525,526,527,528,529,530,
            531,532,533,534,535,536,537,538,539,540,
            541,542,543,544,545,546,547,548,549,550,
            551,552,553,554,555,556,557,558,559,560,
            561,562,563,564,565,566,567,568,569,570,
            571,572,573,574,575,576,577,578,579,580,
            581,582,583,584,585,586,587,588,589,590,
            591,592,593,594,595,596,597,598,599,600,
            601,602,603,604,605,606,607,608,609,610,
            611,612,613,614,615,616,617,618,619,620,
            621,622,623,624,625,626,627,628,629,630,
            631,632,633,634,635,636,637,638,639,640,
            641,642,643,644,645,646,647,648,649,650,
            651,652,653,654,655,656,657,658,659,660,
            661,662,663,664,665,666,667,668,669,670,
            671,672,673,674,675,676,677,678,679,680,
            681,682,683,684,685,686,687,688,689,690,
            691,692,693,694,695,696,697,698,699,700,
            701,702,703,704,705,706,707,708,709,710,
            711,712,713,714,715,716,717,718,719,720,
            721,722,723,724,725,726,727,728,729,730,
            731,732,733,734,735,736,737,0,0,0,
            741,742,4,5,0,756,0,748,749,750,
            751,752,13,0,17,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,27,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,100,101,102,103,104,105,106,107,
            108,109,110,111,112,113,114,115,116,117,
            118,119,120,121,122,123,124,125,126,127,
            128,129,130,131,132,133,134,135,136,137,
            138,139,140,141,142,143,144,145,146,147,
            148,149,150,151,152,153,154,155,156,157,
            158,159,160,161,162,163,164,165,166,167,
            168,169,170,171,172,173,174,175,176,177,
            178,179,180,181,182,183,184,185,186,187,
            188,189,190,191,192,193,194,195,196,197,
            198,199,200,201,202,203,204,205,206,207,
            208,209,210,211,212,213,214,215,216,217,
            218,219,220,221,222,223,224,225,226,227,
            228,229,230,231,232,233,234,235,236,237,
            238,239,240,241,242,243,244,245,246,247,
            248,249,250,251,252,253,254,255,256,257,
            258,259,260,261,262,263,264,265,266,267,
            268,269,270,271,272,273,274,275,276,277,
            278,279,280,281,282,283,284,285,286,287,
            288,289,290,291,292,293,294,295,296,297,
            298,299,300,301,302,303,304,305,306,307,
            308,309,310,311,312,313,314,315,316,317,
            318,319,320,321,322,323,324,325,326,327,
            328,329,330,331,332,333,334,335,336,337,
            338,339,340,341,342,343,344,345,346,347,
            348,349,350,351,352,353,354,355,356,357,
            358,359,360,361,362,363,364,365,366,367,
            368,369,370,371,372,373,374,375,376,377,
            378,379,380,381,382,383,384,385,386,387,
            388,389,390,391,392,393,394,395,396,397,
            398,399,400,401,402,403,404,405,406,407,
            408,409,410,411,412,413,414,415,416,417,
            418,419,420,421,422,423,424,425,426,427,
            428,429,430,431,432,433,434,435,436,437,
            438,439,440,441,442,443,444,445,446,447,
            448,449,450,451,452,453,454,455,456,457,
            458,459,460,461,462,463,464,465,466,467,
            468,469,470,471,472,473,474,475,476,477,
            478,479,480,481,482,483,484,485,486,487,
            488,489,490,491,492,493,494,495,496,497,
            498,499,500,501,502,503,504,505,506,507,
            508,509,510,511,512,513,514,515,516,517,
            518,519,520,521,522,523,524,525,526,527,
            528,529,530,531,532,533,534,535,536,537,
            538,539,540,541,542,543,544,545,546,547,
            548,549,550,551,552,553,554,555,556,557,
            558,559,560,561,562,563,564,565,566,567,
            568,569,570,571,572,573,574,575,576,577,
            578,579,580,581,582,583,584,585,586,587,
            588,589,590,591,592,593,594,595,596,597,
            598,599,600,601,602,603,604,605,606,607,
            608,609,610,611,612,613,614,615,616,617,
            618,619,620,621,622,623,624,625,626,627,
            628,629,630,631,632,633,634,635,636,637,
            638,639,640,641,642,643,644,645,646,647,
            648,649,650,651,652,653,654,655,656,657,
            658,659,660,661,662,663,664,665,666,667,
            668,669,670,671,672,673,674,675,676,677,
            678,679,680,681,682,683,684,685,686,687,
            688,689,690,691,692,693,694,695,696,697,
            698,699,700,701,702,703,704,705,706,707,
            708,709,710,711,712,713,714,715,716,717,
            718,719,720,721,722,723,724,725,726,727,
            728,729,730,731,732,733,734,735,736,737,
            0,738,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,0,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            0,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,101,102,103,104,105,106,107,108,109,
            110,111,112,113,114,115,116,117,118,119,
            120,121,122,123,124,125,126,127,128,129,
            130,131,132,133,134,135,136,137,138,139,
            140,141,142,143,144,145,146,147,148,149,
            150,151,152,153,154,155,156,157,158,159,
            160,161,162,163,164,165,166,167,168,169,
            170,171,172,173,174,175,176,177,178,179,
            180,181,182,183,184,185,186,187,188,189,
            190,191,192,193,194,195,196,197,198,199,
            200,201,202,203,204,205,206,207,208,209,
            210,211,212,213,214,215,216,217,218,219,
            220,221,222,223,224,225,226,227,228,229,
            230,231,232,233,234,235,236,237,238,239,
            240,241,242,243,244,245,246,247,248,249,
            250,251,252,253,254,255,256,257,258,259,
            260,261,262,263,264,265,266,267,268,269,
            270,271,272,273,274,275,276,277,278,279,
            280,281,282,283,284,285,286,287,288,289,
            290,291,292,293,294,295,296,297,298,299,
            300,301,302,303,304,305,306,307,308,309,
            310,311,312,313,314,315,316,317,318,319,
            320,321,322,323,324,325,326,327,328,329,
            330,331,332,333,334,335,336,337,338,339,
            340,341,342,343,344,345,346,347,348,349,
            350,351,352,353,354,355,356,357,358,359,
            360,361,362,363,364,365,366,367,368,369,
            370,371,372,373,374,375,376,377,378,379,
            380,381,382,383,384,385,386,387,388,389,
            390,391,392,393,394,395,396,397,398,399,
            400,401,402,403,404,405,406,407,408,409,
            410,411,412,413,414,415,416,417,418,419,
            420,421,422,423,424,425,426,427,428,429,
            430,431,432,433,434,435,436,437,438,439,
            440,441,442,443,444,445,446,447,448,449,
            450,451,452,453,454,455,456,457,458,459,
            460,461,462,463,464,465,466,467,468,469,
            470,471,472,473,474,475,476,477,478,479,
            480,481,482,483,484,485,486,487,488,489,
            490,491,492,493,494,495,496,497,498,499,
            500,501,502,503,504,505,506,507,508,509,
            510,511,512,513,514,515,516,517,518,519,
            520,521,522,523,524,525,526,527,528,529,
            530,531,532,533,534,535,536,537,538,539,
            540,541,542,543,544,545,546,547,548,549,
            550,551,552,553,554,555,556,557,558,559,
            560,561,562,563,564,565,566,567,568,569,
            570,571,572,573,574,575,576,577,578,579,
            580,581,582,583,584,585,586,587,588,589,
            590,591,592,593,594,595,596,597,598,599,
            600,601,602,603,604,605,606,607,608,609,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,648,649,
            650,651,652,653,654,655,656,657,658,659,
            660,661,662,663,664,665,666,667,668,669,
            670,671,672,673,674,675,676,677,678,679,
            680,681,682,683,684,685,686,687,688,689,
            690,691,692,693,694,695,696,697,698,699,
            700,701,702,703,704,705,706,707,708,709,
            710,711,712,713,714,715,716,717,718,719,
            720,721,722,723,724,725,726,727,728,729,
            730,731,732,733,734,735,736,737,0,1,
            2,0,1,2,742,3,0,3,6,7,
            8,9,10,11,12,13,0,0,20,0,
            739,23,5,17,26,0,1,2,3,27,
            28,29,34,31,0,33,0,20,40,35,
            39,21,17,45,46,0,48,49,50,51,
            52,53,54,55,0,57,15,3,1,2,
            6,4,5,9,0,24,12,69,70,33,
            0,1,2,16,76,18,19,14,21,7,
            8,83,10,11,86,66,88,89,0,47,
            92,93,0,1,2,0,4,5,56,30,
            1,2,38,31,40,0,64,0,16,40,
            18,19,5,43,72,73,74,29,0,6,
            21,58,9,81,6,12,41,9,65,59,
            12,26,25,91,21,40,4,7,8,0,
            10,11,0,0,37,0,82,0,16,14,
            87,19,13,1,2,0,1,2,15,90,
            0,14,0,21,0,39,0,24,0,0,
            85,0,67,38,32,0,71,22,0,0,
            63,15,0,23,0,68,60,42,0,25,
            21,0,0,0,34,0,18,0,0,0,
            0,37,0,35,22,0,44,0,0,4,
            0,36,14,20,62,0,32,0,0,0,
            75,30,0,28,0,0,0,0,0,0,
            0,0,61,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,77,0,0,0,
            0,0,0,0,0,0,0,79,0,0,
            0,0,80,0,0,78,0,0,0,0,
            0,0,0,84,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,741,
            742,0,0,0,738,0,748,749,750,751,
            752,0,0,0,0,0,740,0,738,743,
            744,745,746,747,0,0,0,0,0,0,
            0,0,0,0,0,741,0,0,0,0,
            739,739,0,0,0,740,0,0,0,0,
            0,0,0,0,0,753,754,740,0,0,
            743,744,745,746,747,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,740,0,0,743,744,745,746,747,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,738,0,0,
            0,0,0,0,0,738,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0
        };
    };
    public final static char shiftCheck[] = ShiftCheck.shiftCheck;
    public final int shiftCheck(int index) { return shiftCheck[index]; }

    public interface DefaultShift {
        public final static char defaultShift[] = {0,
            1648,1408,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2331,
            3099,2328,2328,2328,2328,2351,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,1548,
            2328,2328,2328,2328,2343,2339,2328,2407,2387,2383,
            2379,2403,2399,2375,2371,2328,2335,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2395,2391,
            2328,2328,2328,2328,2328,2347,2328,2328,2328,2328,
            2328,2328,2367,2328,2328,2363,2328,2359,2355,2328,
            2328,2328,2325,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,2328,2328,2328,
            2328,2328,2328,2328,2328,2328,2328,1921,2143,3056,
            903,2819,3057,3060,3059,3061,3058,2825,2826,2822,
            3033,3034,2129,1676,860,749,2975,3062,2976,3063,
            2504,2770,2770,2770,2770,2770,2770,2770,2770,2770,
            2770,2770,2770,2770,2770,2770,2770,2770,2770
        };
    };
    public final static char defaultShift[] = DefaultShift.defaultShift;
    public final int defaultShift(int index) { return defaultShift[index]; }

    public interface Asb {
        public final static char asb[] = {0,
            2253,2309,3875,3116,7,2257,3116,2308,2334,3116,
            3116,3946,22,3116,762,1517,2257,2283,1507,1512,
            2264,3114,2291,3116,3116,2256,762,3964,1517,1517,
            2259,1517,3101,2348,2348,3946,2350,3116,3116,3100,
            3100,3100,3101,3853,1517,2286,2257,3869,3869,3869,
            3116,3903,3116,1517,3925,1526,2256,3116,3874,1517,
            2359,3946,3946,2363,1517,1517,9,1517,3,3946,
            3877,3116,1,1,1,1517,1517,1517,1517,1517,
            1517,760,3880,3883,2259,3880,3969,13,1517,3925,
            3116,2326,3116,3924,1517,3880,762,1526,3884,3116,
            3888,3116,3903,3890,3901,3098,1517,3917,1517,2321,
            2259,1516,2314,2269,2271,2270,9,1517,3116,1515,
            760,760,760,3101,3101,1517,2257,3116,1517,17,
            3880,1517,1526,3969,3858,1516,3116,2279,2274,2259,
            1526,3112,3946,3946,3116,3096,1517,1516,2259,2257,
            760,3971,3905,2312,3908,1517,1517,2259,3911,1517,
            2344,1517,1517,3098,3915,1516,760,3883,2286,3919,
            2326,3922,1517,760,3971,1526,2302,3848,2261,2261,
            2261,1526,755,1526,2286,2293,3116,3888,760,3946,
            3929,3933,3933,2259,3933,3933,2259,3931,3931,3933,
            3933,3933,3938,3933,3943,3934,3094,3905,1516,2286,
            2321,1517,3909,2266,3948,1517,1517,1517,2259,2259,
            2259,2259,2267,2345,2270,1517,760,3880,3883,2259,
            1517,2274,2282,2264,1526,3116,2286,2286,3116,3112,
            3116,3952,1,1,1,1,1,1,3952,2259,
            1,3952,2259,1,1,1,1,1,2328,760,
            3954,3883,2348,1517,3880,2266,3948,1517,2256,3094,
            1517,3883,1517,1517,3843,2259,3116,27,3933,3864,
            3864,760,760,3864,760,3933,1,760,3933,1,
            760,3880,3880,3880,760,1,2259,2259,3957,2267,
            1517,3880,2286,3880,1517,2281,2259,2259,3960,3973,
            3975,3962,1516,1517,1516,1,760,760,760,1,
            760,1,760,1,1,1,3850,2259,3913,2267,
            1517,1517,1517,2259,1517,1504,3880,3883,760,3864,
            3864,3864,760,760,760,2259,1516,3880,1517,3880,
            1517,1517,760,760,760,760,3880,1516,3116,1517,
            3880,1472
        };
    };
    public final static char asb[] = Asb.asb;
    public final int asb(int index) { return asb[index]; }

    public interface Asr {
        public final static char asr[] = {0,
            741,0,39,1,2,0,66,0,61,39,
            60,0,43,59,1,2,738,755,761,77,
            0,40,738,755,761,756,734,733,732,731,
            730,729,728,727,726,725,724,723,722,721,
            720,719,718,717,716,715,714,713,712,711,
            710,709,708,707,706,705,704,703,702,701,
            91,700,699,698,697,696,695,694,693,14,
            692,13,39,691,690,689,688,687,90,686,
            685,684,38,89,683,682,88,681,680,679,
            678,677,87,676,675,674,673,672,671,670,
            669,668,667,666,665,664,37,663,662,661,
            660,659,658,657,656,655,654,653,652,651,
            650,649,648,36,647,646,645,644,643,642,
            641,640,639,86,638,637,636,635,634,633,
            632,631,630,629,628,627,626,625,624,623,
            622,621,620,619,618,617,616,615,614,613,
            612,611,610,609,608,607,606,605,604,603,
            602,601,85,600,599,598,597,596,595,594,
            593,84,35,83,592,591,590,589,588,587,
            586,585,584,82,583,582,81,581,580,579,
            578,577,576,575,574,573,572,571,570,569,
            568,567,566,565,564,34,563,562,561,560,
            559,558,557,556,555,554,553,552,551,550,
            549,548,547,546,545,544,543,542,541,540,
            539,538,537,536,535,534,533,532,531,530,
            529,528,527,526,525,524,523,522,521,520,
            519,518,517,516,515,514,513,512,511,510,
            509,508,507,506,505,504,503,502,501,500,
            499,498,80,497,496,495,494,493,492,491,
            490,489,488,487,486,485,484,483,482,481,
            480,479,478,477,476,475,474,473,472,79,
            471,470,33,32,469,468,467,466,465,464,
            463,462,31,461,460,459,458,457,456,78,
            455,454,453,452,451,77,20,5,450,449,
            448,447,446,445,444,443,442,441,440,439,
            438,437,436,435,434,76,75,433,74,432,
            431,430,429,428,427,73,426,425,72,424,
            423,422,421,420,419,418,417,416,415,414,
            413,412,411,410,71,409,408,407,406,405,
            404,403,402,401,400,399,70,69,398,397,
            396,395,394,393,19,392,391,390,389,388,
            387,386,385,384,68,30,383,382,381,380,
            379,67,378,377,376,375,374,18,373,372,
            371,66,370,369,368,367,366,365,364,65,
            363,362,361,360,359,358,357,356,355,354,
            353,352,351,350,349,348,347,346,4,345,
            344,343,342,341,340,339,64,338,337,336,
            335,334,28,333,332,331,27,330,329,328,
            327,326,325,324,323,322,26,321,320,17,
            319,318,317,316,315,314,313,312,311,310,
            63,309,308,307,306,305,304,303,25,302,
            301,300,299,298,297,296,295,294,293,292,
            291,290,289,288,287,286,285,284,283,282,
            281,62,280,279,278,61,277,276,275,274,
            60,273,272,271,270,269,268,267,266,265,
            264,263,24,262,261,260,259,258,257,256,
            255,254,253,252,251,59,58,250,249,248,
            247,246,245,57,244,243,242,241,240,239,
            238,237,236,235,234,233,232,231,230,229,
            228,227,226,225,224,56,223,222,221,220,
            219,218,217,216,215,55,54,53,52,51,
            50,49,48,214,23,213,212,211,210,209,
            208,207,206,205,204,203,202,201,200,199,
            198,197,196,195,194,193,192,191,190,189,
            188,187,186,47,185,184,183,182,181,180,
            179,178,177,176,175,174,173,172,171,170,
            169,168,167,166,165,164,163,162,161,160,
            159,46,45,158,157,156,155,154,153,152,
            151,150,149,148,147,44,146,145,144,143,
            142,141,140,139,138,137,136,135,134,133,
            16,132,131,130,129,128,127,126,125,124,
            123,122,121,120,119,118,117,116,115,114,
            113,43,42,112,111,110,109,41,22,108,
            107,106,105,104,15,103,102,101,100,99,
            98,97,96,95,94,735,736,737,92,93,
            6,9,12,3,29,8,10,11,7,21,
            0,737,736,735,734,733,732,731,730,729,
            728,727,726,725,724,723,722,721,720,719,
            718,717,716,715,714,713,712,711,710,709,
            708,707,706,705,704,703,702,701,91,700,
            699,698,697,696,695,694,693,14,692,13,
            39,691,690,689,688,687,90,686,685,684,
            38,683,682,681,680,679,678,677,87,676,
            675,674,12,673,672,671,670,669,668,667,
            666,665,664,37,663,662,661,660,659,658,
            657,656,655,654,653,652,651,650,649,648,
            36,647,646,645,644,643,642,641,640,639,
            638,637,636,635,634,633,632,631,630,629,
            628,627,626,625,624,623,622,621,620,619,
            618,617,616,615,614,613,612,611,610,609,
            608,607,606,605,604,603,602,601,85,600,
            599,598,597,596,595,594,593,84,35,592,
            591,590,589,588,587,586,585,584,82,583,
            582,81,581,580,579,578,577,576,575,574,
            573,572,571,570,569,568,567,566,565,564,
            563,11,562,561,560,559,558,557,556,555,
            554,553,552,551,550,549,548,547,546,545,
            544,543,542,541,540,539,538,537,536,535,
            534,533,532,531,530,529,528,527,526,525,
            524,523,522,521,520,519,518,517,516,515,
            514,513,512,511,510,509,508,507,506,505,
            504,503,502,501,500,499,498,80,497,496,
            495,494,493,492,491,490,489,488,487,486,
            485,484,483,482,481,480,479,478,477,476,
            475,474,473,472,79,471,470,33,32,469,
            468,467,466,465,464,463,462,31,461,460,
            459,458,457,456,78,455,454,453,452,451,
            77,5,450,449,448,447,446,445,444,443,
            442,441,440,439,438,437,436,435,434,75,
            433,74,432,431,430,429,428,427,73,426,
            425,72,424,423,422,421,420,419,418,417,
            416,415,414,413,412,411,410,71,409,408,
            407,406,405,404,403,402,401,400,399,398,
            397,396,395,394,393,19,392,391,390,389,
            388,10,387,386,385,384,68,30,383,382,
            381,380,379,67,29,378,377,376,375,374,
            18,373,372,371,66,9,370,369,368,367,
            366,365,364,65,363,362,361,8,360,359,
            358,357,356,355,354,353,352,351,350,349,
            348,347,346,4,345,344,343,342,341,340,
            339,64,338,337,336,335,334,28,333,332,
            331,27,330,329,328,327,326,325,324,323,
            322,321,7,320,17,319,318,317,316,315,
            314,313,312,311,310,63,309,308,307,306,
            305,304,303,25,302,301,300,299,298,297,
            296,295,294,293,292,291,290,289,288,287,
            286,6,285,284,283,282,281,62,280,279,
            278,61,277,276,275,274,60,273,272,271,
            270,269,268,267,266,265,264,263,262,261,
            260,259,258,257,256,255,254,253,252,251,
            59,58,250,249,248,247,246,245,244,243,
            242,241,240,239,238,237,236,235,234,233,
            232,231,230,229,228,227,226,225,224,56,
            223,222,221,220,219,218,217,216,215,214,
            213,212,211,210,209,208,207,206,205,204,
            203,202,201,200,199,198,197,196,195,194,
            193,192,191,190,189,188,187,186,47,185,
            184,183,182,181,180,179,178,177,176,175,
            174,173,172,171,170,169,168,167,166,165,
            164,163,162,161,160,159,158,157,156,155,
            154,153,152,151,150,149,148,147,44,146,
            145,144,143,142,141,140,139,138,137,136,
            135,134,133,16,132,131,130,129,128,127,
            126,125,124,123,122,121,120,119,118,117,
            116,115,114,113,43,3,42,112,111,110,
            109,41,22,108,107,106,105,104,103,102,
            101,100,99,98,97,96,95,94,739,15,
            24,40,1,2,57,20,46,45,751,752,
            742,26,76,750,741,748,749,92,93,48,
            52,53,69,70,49,50,51,54,55,83,
            86,88,89,23,34,0,82,38,40,738,
            0,3,40,0,739,21,742,750,741,748,
            749,751,752,1,2,737,736,735,734,733,
            732,731,730,729,728,727,726,725,724,723,
            722,721,720,719,718,717,716,715,714,713,
            712,711,710,709,708,707,706,705,704,703,
            702,701,91,700,699,698,697,696,695,694,
            693,692,13,39,691,690,689,688,687,90,
            686,685,684,89,683,682,88,681,680,679,
            678,677,676,675,674,12,673,672,671,670,
            669,668,667,666,665,664,37,663,662,661,
            660,659,658,657,656,655,654,653,652,651,
            650,649,648,36,647,646,645,644,643,642,
            641,640,639,86,638,637,636,635,634,633,
            632,631,630,629,628,627,626,625,624,623,
            622,621,620,619,618,617,616,615,614,613,
            612,611,610,609,608,607,606,605,604,603,
            602,601,85,600,599,598,597,596,595,594,
            593,84,35,83,592,591,590,589,588,587,
            586,585,584,583,582,81,581,580,579,578,
            577,576,575,574,573,572,571,570,569,568,
            567,566,565,564,34,563,11,562,561,560,
            559,558,557,556,555,554,553,552,551,550,
            549,548,547,546,545,544,543,542,541,540,
            539,538,537,536,535,534,533,532,531,530,
            529,528,527,526,525,524,523,522,521,520,
            519,518,517,516,515,514,513,512,511,510,
            509,508,507,506,505,504,503,502,501,500,
            499,498,80,497,496,495,494,493,492,491,
            490,489,488,487,486,485,484,483,482,481,
            480,479,478,477,476,475,474,473,472,79,
            471,470,33,32,469,468,467,466,465,464,
            463,462,31,461,460,459,458,457,456,78,
            455,454,453,452,451,77,20,5,450,449,
            448,447,446,445,444,443,442,441,440,439,
            438,437,436,435,434,76,75,433,74,432,
            431,430,429,428,427,73,426,425,72,424,
            423,422,421,420,419,418,417,416,415,414,
            413,412,411,410,71,409,408,407,406,405,
            404,403,402,401,400,399,70,69,398,397,
            396,395,394,393,19,392,391,390,389,388,
            10,387,386,385,384,68,30,383,382,381,
            380,379,67,29,378,377,376,375,374,18,
            373,372,371,66,9,370,369,368,367,366,
            365,364,363,362,361,8,360,359,358,357,
            356,355,354,353,352,351,350,349,348,347,
            346,4,345,344,343,342,341,340,339,64,
            338,337,336,335,334,28,333,332,331,27,
            330,329,328,327,326,325,324,323,322,26,
            321,7,320,17,319,318,317,316,315,314,
            313,312,311,310,63,309,308,307,306,305,
            304,303,25,302,301,300,299,298,297,296,
            295,294,293,292,291,290,289,288,287,286,
            6,285,284,283,282,281,62,280,279,278,
            61,277,276,275,274,60,273,272,271,270,
            269,268,267,266,265,264,263,24,262,261,
            260,259,258,257,256,255,254,253,252,251,
            59,250,249,248,247,246,245,57,244,243,
            242,241,240,239,238,237,236,235,234,233,
            232,231,230,229,228,227,226,225,224,56,
            223,222,221,220,219,218,217,216,215,55,
            54,53,52,51,50,49,48,214,23,213,
            212,211,210,209,208,207,206,205,204,203,
            202,201,200,199,198,197,196,195,194,193,
            192,191,190,189,188,187,186,47,185,184,
            183,182,181,180,179,178,177,176,175,174,
            173,172,171,170,169,168,167,166,165,164,
            163,162,161,160,159,46,45,158,157,156,
            155,154,153,152,151,150,149,148,147,44,
            146,145,144,143,142,141,140,139,138,137,
            136,135,134,133,16,132,131,130,129,128,
            127,126,125,124,123,122,121,120,119,118,
            117,116,115,114,113,43,3,42,112,111,
            110,109,41,22,108,107,106,105,104,15,
            103,102,101,100,99,98,97,96,95,94,
            92,93,65,87,58,14,38,82,40,0,
            29,79,0,44,0,62,1,2,18,22,
            31,36,32,29,8,10,11,7,27,13,
            738,28,33,755,761,12,9,6,21,0,
            35,0,7,8,29,10,31,11,13,738,
            40,6,28,9,12,21,27,33,761,755,
            0,738,21,1,2,5,4,16,19,18,
            743,747,745,744,746,740,0,42,75,21,
            757,759,0,755,761,82,38,40,14,65,
            87,58,0,5,37,25,0,742,0,21,
            743,740,744,745,746,747,755,761,739,753,
            754,756,736,735,734,733,732,731,730,729,
            728,727,726,725,724,723,722,721,720,719,
            718,717,716,715,714,713,712,711,710,709,
            708,707,706,705,704,703,702,701,91,700,
            699,698,697,696,695,694,693,14,692,13,
            691,690,689,688,687,90,686,685,684,38,
            89,683,682,88,681,680,679,678,677,87,
            676,675,674,12,673,672,671,670,669,668,
            667,666,665,664,37,663,662,661,660,659,
            658,657,656,655,654,653,652,651,650,649,
            648,36,647,646,645,644,643,642,641,640,
            639,86,638,637,636,635,634,633,632,631,
            630,629,628,627,626,625,624,623,622,621,
            620,619,618,617,616,615,614,613,612,611,
            610,609,608,607,606,605,604,603,602,601,
            85,600,599,598,597,596,595,594,593,84,
            35,83,592,591,590,589,588,587,586,585,
            584,82,583,582,81,581,580,579,578,577,
            576,575,574,573,572,571,570,569,568,567,
            566,565,564,34,563,11,562,561,560,559,
            558,557,556,555,554,553,552,551,550,549,
            548,547,546,545,544,543,542,541,540,539,
            538,537,536,535,534,533,532,531,530,529,
            528,527,526,525,524,523,522,521,520,519,
            518,517,516,515,514,513,512,511,510,509,
            508,507,506,505,504,503,502,501,500,499,
            498,80,497,496,495,494,493,492,491,490,
            489,488,487,486,485,484,483,482,481,480,
            479,478,477,476,475,474,473,472,79,471,
            470,33,32,469,468,467,466,465,464,463,
            462,31,461,460,459,458,457,456,78,455,
            454,453,452,451,77,20,5,450,449,448,
            447,446,445,444,443,442,441,440,439,438,
            437,436,435,434,76,75,433,74,432,431,
            430,429,428,427,73,426,425,72,424,423,
            422,421,420,419,418,417,416,415,414,413,
            412,411,410,71,409,408,407,406,405,404,
            403,402,401,400,399,70,69,398,397,396,
            395,394,393,19,392,391,390,389,388,10,
            387,386,385,384,68,30,383,382,381,380,
            379,67,29,378,377,376,375,374,18,373,
            372,371,66,9,370,369,368,367,366,365,
            364,65,363,362,361,8,360,359,358,357,
            356,355,354,353,352,351,350,349,348,347,
            346,4,345,344,343,342,341,340,339,64,
            338,337,336,335,334,28,333,332,331,27,
            330,329,328,327,326,325,324,323,322,26,
            321,7,320,319,318,317,316,315,314,313,
            312,311,310,63,309,308,307,306,305,304,
            303,25,302,301,300,299,298,297,296,295,
            294,293,292,291,290,289,288,287,286,6,
            285,284,283,282,281,62,280,279,278,277,
            276,275,274,273,272,271,270,269,268,267,
            266,265,264,263,24,262,261,260,259,258,
            257,256,255,254,253,252,251,59,58,250,
            249,248,247,246,245,57,244,243,242,241,
            240,239,238,237,236,235,234,233,232,231,
            230,229,228,227,226,225,224,56,223,222,
            221,220,219,218,217,216,215,55,54,53,
            52,51,50,49,48,214,23,213,212,211,
            210,209,208,207,206,205,204,203,202,201,
            200,199,198,197,196,195,194,193,192,191,
            190,189,188,187,186,47,185,184,183,182,
            181,180,179,178,177,176,175,174,173,172,
            171,170,169,168,167,166,165,164,163,162,
            161,160,159,46,45,158,157,156,155,154,
            153,152,151,150,149,148,147,44,146,145,
            144,143,142,141,140,139,138,137,136,135,
            134,133,16,132,131,130,129,128,127,126,
            125,124,123,122,121,120,119,118,117,116,
            115,114,113,43,42,112,111,110,109,41,
            22,108,107,106,105,104,15,103,102,101,
            100,99,98,97,96,95,94,737,738,92,
            93,17,3,60,39,1,2,61,0,40,
            739,1,2,753,743,740,744,745,746,747,
            754,21,738,755,761,737,736,735,734,733,
            732,731,730,729,728,727,726,725,724,723,
            722,721,720,719,718,717,716,715,714,713,
            712,711,710,709,708,707,706,705,704,703,
            702,701,91,700,699,698,697,696,695,694,
            693,14,692,13,39,691,690,689,688,687,
            90,686,685,684,38,89,683,682,88,681,
            680,679,678,677,87,676,675,674,12,673,
            672,671,670,669,668,667,666,665,664,37,
            663,662,661,660,659,658,657,656,655,654,
            653,652,651,650,649,648,36,647,646,645,
            644,643,642,641,640,639,86,638,637,636,
            635,634,633,632,631,630,629,628,627,626,
            625,624,623,622,621,620,619,618,617,616,
            615,614,613,612,611,610,609,608,607,606,
            605,604,603,602,601,85,600,599,598,597,
            596,595,594,593,84,35,83,592,591,590,
            589,588,587,586,585,584,82,583,582,81,
            581,580,579,578,577,576,575,574,573,572,
            571,570,569,568,567,566,565,564,34,563,
            562,561,560,559,558,557,556,555,554,553,
            552,551,550,549,548,547,546,545,544,543,
            542,541,540,539,538,537,536,535,534,533,
            532,531,530,529,528,527,526,525,524,523,
            522,521,520,519,518,517,516,515,514,513,
            512,511,510,509,508,507,506,505,504,503,
            502,501,500,499,498,80,497,496,495,494,
            493,492,491,490,489,488,487,486,485,484,
            483,482,481,480,479,478,477,476,475,474,
            473,472,79,471,470,33,32,469,468,467,
            466,465,464,463,462,461,460,459,458,457,
            456,78,455,454,453,452,451,77,20,5,
            450,449,448,447,446,445,444,443,442,441,
            440,439,438,437,436,435,434,76,75,433,
            74,432,431,430,429,428,427,73,426,425,
            72,424,423,422,421,420,419,418,417,416,
            415,414,413,412,411,410,71,409,408,407,
            406,405,404,403,402,401,400,399,70,69,
            398,397,396,395,394,393,19,392,391,390,
            389,388,387,386,385,384,68,30,383,382,
            381,380,379,67,378,377,376,375,374,18,
            373,372,371,66,9,370,369,368,367,366,
            365,364,65,363,362,361,360,359,358,357,
            356,355,354,353,352,351,350,349,348,347,
            346,4,345,344,343,342,341,340,339,64,
            338,337,336,335,334,28,333,332,331,27,
            330,329,328,327,326,325,324,323,322,26,
            321,320,17,319,318,317,316,315,314,313,
            312,311,310,63,309,308,307,306,305,304,
            303,25,302,301,300,299,298,297,296,295,
            294,293,292,291,290,289,288,287,286,6,
            285,284,283,282,281,62,280,279,278,61,
            277,276,275,274,60,273,272,271,270,269,
            268,267,266,265,264,263,24,262,261,260,
            259,258,257,256,255,254,253,252,251,59,
            58,250,249,248,247,246,245,57,244,243,
            242,241,240,239,238,237,236,235,234,233,
            232,231,230,229,228,227,226,225,224,56,
            223,222,221,220,219,218,217,216,215,55,
            54,53,52,51,50,49,48,214,23,213,
            212,211,210,209,208,207,206,205,204,203,
            202,201,200,199,198,197,196,195,194,193,
            192,191,190,189,188,187,186,47,185,184,
            183,182,181,180,179,178,177,176,175,174,
            173,172,171,170,169,168,167,166,165,164,
            163,162,161,160,159,46,45,158,157,156,
            155,154,153,152,151,150,149,148,147,44,
            146,145,144,143,142,141,140,139,138,137,
            136,135,134,133,16,132,131,130,129,128,
            127,126,125,124,123,122,121,120,119,118,
            117,116,115,114,113,43,3,42,112,111,
            110,109,41,22,108,107,106,105,104,15,
            103,102,101,100,99,98,97,96,95,94,
            92,93,8,10,11,7,31,29,0,758,
            760,0,6,9,33,12,21,738,755,761,
            1,2,0,21,67,71,26,0,82,38,
            40,15,0,738,17,0,756,40,0,738,
            21,0,738,1,2,21,0,739,0,47,
            56,64,72,73,74,81,91,739,753,754,
            1,2,3,0,32,21,0,5,20,0,
            16,19,4,0,1,2,36,0,63,68,
            0,1,2,738,755,761,13,0,30,0,
            90,30,40,21,42,75,0,42,75,21,
            80,0,42,75,21,756,0,1,2,22,
            0,78,0,41,85,0,5,4,0,1,
            2,14,28,6,9,33,12,21,755,761,
            738,0,84,0,14,738,0
        };
    };
    public final static char asr[] = Asr.asr;
    public final int asr(int index) { return asr[index]; }

    public interface Nasb {
        public final static char nasb[] = {0,
            120,8,8,7,8,91,123,31,120,7,
            13,8,8,7,50,6,91,20,8,60,
            8,13,8,94,94,42,6,8,6,6,
            8,112,8,8,8,8,8,7,56,8,
            8,8,11,8,4,20,27,8,8,8,
            93,8,74,6,66,38,120,6,8,4,
            8,8,8,101,6,6,24,33,18,8,
            8,7,9,62,9,6,6,6,6,6,
            6,8,8,8,8,8,8,44,33,66,
            6,8,94,8,6,8,6,7,8,94,
            8,29,8,8,8,8,6,8,78,22,
            8,1,22,8,8,8,96,6,52,50,
            8,8,8,11,11,6,91,68,6,16,
            8,6,46,8,8,3,6,66,64,8,
            90,126,8,8,7,8,6,1,81,91,
            8,8,8,22,8,6,6,76,8,6,
            99,33,33,8,8,6,8,8,20,8,
            8,8,6,8,8,7,85,8,70,70,
            70,108,64,90,20,60,94,8,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,8,8,8,8,116,20,
            8,6,8,72,8,4,6,6,76,76,
            76,76,8,99,8,6,8,8,8,8,
            6,64,54,8,7,7,20,20,126,126,
            7,8,8,8,8,8,8,8,8,8,
            8,8,8,8,8,8,8,8,83,8,
            8,8,8,6,8,72,8,4,120,8,
            89,8,33,6,64,8,126,126,8,106,
            106,8,8,106,8,8,8,8,8,8,
            8,8,8,8,8,8,76,76,8,8,
            6,8,20,8,87,8,8,8,8,8,
            8,8,4,33,6,8,8,8,8,8,
            8,8,8,8,8,8,104,76,8,8,
            6,6,6,8,6,8,8,8,8,106,
            106,106,8,8,8,76,4,8,4,8,
            6,6,8,8,8,8,8,4,126,6,
            8,6
        };
    };
    public final static char nasb[] = Nasb.nasb;
    public final int nasb(int index) { return nasb[index]; }

    public interface Nasr {
        public final static char nasr[] = {0,
            24,38,51,18,17,4,1,0,86,0,
            59,0,26,73,0,129,0,94,0,39,
            0,56,0,69,70,0,21,0,92,0,
            130,0,38,24,4,1,0,138,4,1,
            0,124,0,126,0,4,1,88,0,75,
            0,5,0,128,0,2,4,132,0,82,
            0,136,0,54,0,58,0,72,0,61,
            0,81,0,100,0,3,0,4,1,27,
            24,0,106,0,127,0,18,17,4,1,
            29,0,90,16,0,69,71,0,68,0,
            26,125,0,107,0,44,0,29,2,4,
            0,4,1,93,0,4,1,51,0,17,
            18,0,16,139,0,40,26,0
        };
    };
    public final static char nasr[] = Nasr.nasr;
    public final int nasr(int index) { return nasr[index]; }

    public interface TerminalIndex {
        public final static char terminalIndex[] = {0,
            8,10,52,318,443,249,288,334,346,370,
            564,686,711,713,39,74,286,351,376,444,
            4,45,160,222,267,290,300,304,357,364,
            458,467,468,566,599,658,675,700,710,3,
            46,51,53,89,102,103,131,162,163,164,
            165,166,167,168,169,179,201,208,209,234,
            239,243,275,310,338,347,358,365,383,384,
            396,412,415,422,424,425,445,451,471,498,
            585,588,598,600,609,648,690,696,699,704,
            722,761,762,29,30,31,32,33,34,35,
            36,37,38,40,41,42,43,44,47,48,
            49,50,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,75,76,77,78,79,80,81,82,
            83,84,85,86,87,88,90,91,92,93,
            94,95,96,97,98,99,100,101,104,105,
            106,107,108,109,110,111,112,113,114,115,
            116,117,118,119,120,121,122,123,124,125,
            126,127,128,129,130,132,133,134,135,136,
            137,138,139,140,141,142,143,144,145,146,
            147,148,149,150,151,152,153,154,155,156,
            157,158,159,161,170,171,172,173,174,175,
            176,177,178,180,181,182,183,184,185,186,
            187,188,189,190,191,192,193,194,195,196,
            197,198,199,200,202,203,204,205,206,207,
            210,211,212,213,214,215,216,217,218,219,
            220,221,223,224,225,226,227,228,229,230,
            231,232,233,235,236,237,238,240,241,242,
            244,245,246,247,248,250,251,252,253,254,
            255,256,257,258,259,260,261,262,263,264,
            265,266,268,269,270,271,272,273,274,276,
            277,278,279,280,281,282,283,284,285,287,
            289,291,292,293,294,295,296,297,298,299,
            301,302,303,305,306,307,308,309,311,312,
            313,314,315,316,317,319,320,321,322,323,
            324,325,326,327,328,329,330,331,332,333,
            335,336,337,339,340,341,342,343,344,345,
            348,349,350,352,353,354,355,356,359,360,
            361,362,363,366,367,368,369,371,372,373,
            374,375,377,378,379,380,381,382,385,386,
            387,388,389,390,391,392,393,394,395,397,
            398,399,400,401,402,403,404,405,406,407,
            408,409,410,411,413,414,416,417,418,419,
            420,421,423,426,427,428,429,430,431,432,
            433,434,435,436,437,438,439,440,441,442,
            446,447,448,449,450,452,453,454,455,456,
            457,459,460,461,462,463,464,465,466,469,
            470,472,473,474,475,476,477,478,479,480,
            481,482,483,484,485,486,487,488,489,490,
            491,492,493,494,495,496,497,499,500,501,
            502,503,504,505,506,507,508,509,510,511,
            512,513,514,515,516,517,518,519,520,521,
            522,523,524,525,526,527,528,529,530,531,
            532,533,534,535,536,537,538,539,540,541,
            542,543,544,545,546,547,548,549,550,551,
            552,553,554,555,556,557,558,559,560,561,
            562,563,565,567,568,569,570,571,572,573,
            574,575,576,577,578,579,580,581,582,583,
            584,586,587,589,590,591,592,593,594,595,
            596,597,601,602,603,604,605,606,607,608,
            610,611,612,613,614,615,616,617,618,619,
            620,621,622,623,624,625,626,627,628,629,
            630,631,632,633,634,635,636,637,638,639,
            640,641,642,643,644,645,646,647,649,650,
            651,652,653,654,655,656,657,659,660,661,
            662,663,664,665,666,667,668,669,670,671,
            672,673,674,676,677,678,679,680,681,682,
            683,684,685,687,688,689,691,692,693,694,
            695,697,698,701,702,703,705,706,707,708,
            709,712,714,715,716,717,718,719,720,721,
            723,724,725,726,727,728,729,730,731,732,
            733,734,735,736,737,738,739,740,741,742,
            743,744,745,746,747,748,749,750,751,752,
            753,754,755,756,757,758,759,9,7,16,
            764,772,15,17,21,22,23,766,767,771,
            777,778,12,24,776,11,19,20,779,780,
            1,5,6,13,14,18,760,25,26,763,
            765,768,769,770,773,774,775,781,2
        };
    };
    public final static char terminalIndex[] = TerminalIndex.terminalIndex;
    public final int terminalIndex(int index) { return terminalIndex[index]; }

    public interface NonterminalIndex {
        public final static char nonterminalIndex[] = {0,
            785,830,788,0,804,807,0,0,0,817,
            0,0,0,815,786,808,827,0,818,816,
            836,0,0,839,0,0,795,0,814,0,
            0,0,0,0,0,0,792,793,835,789,
            791,842,790,0,0,0,831,0,845,0,
            0,799,822,0,844,787,811,0,813,828,
            0,783,0,0,0,0,0,794,0,798,
            800,805,0,812,0,0,0,820,823,825,
            0,0,0,832,834,840,843,848,849,851,
            782,784,796,797,801,802,0,803,0,806,
            0,0,0,0,0,809,810,0,0,0,
            0,0,0,0,0,0,0,0,819,821,
            824,0,826,0,0,0,0,0,0,0,
            829,833,837,27,838,841,846,847,850,0,
            0,0,0,0,0
        };
    };
    public final static char nonterminalIndex[] = NonterminalIndex.nonterminalIndex;
    public final int nonterminalIndex(int index) { return nonterminalIndex[index]; }

    public interface ScopePrefix {
        public final static char scopePrefix[] = {
            25,1,178,198,168,193,233,39,123,134,
            134,50,54,212,247,251,15,85,85,111,
            216,71,9,12,36,47,58,22,190,204,
            255,22,224,230,240,12,12,9,9,81,
            61,66,61,61,207,61,61,61,61,61,
            61,61,61,61,61,61
        };
    };
    public final static char scopePrefix[] = ScopePrefix.scopePrefix;
    public final int scopePrefix(int index) { return scopePrefix[index]; }

    public interface ScopeSuffix {
        public final static char scopeSuffix[] = {
            32,7,7,7,7,7,238,44,115,139,
            149,7,7,7,238,7,19,89,92,115,
            220,75,7,7,7,7,7,7,7,7,
            7,19,227,227,243,258,263,143,154,83,
            63,68,95,161,209,98,102,164,268,272,
            276,106,118,173,128,184
        };
    };
    public final static char scopeSuffix[] = ScopeSuffix.scopeSuffix;
    public final int scopeSuffix(int index) { return scopeSuffix[index]; }

    public interface ScopeLhs {
        public final static char scopeLhs[] = {
            49,90,30,13,30,77,7,48,31,30,
            30,46,46,28,7,38,50,127,127,31,
            8,22,89,24,49,55,3,21,78,10,
            38,50,71,70,7,25,25,30,30,17,
            36,35,33,30,51,33,32,30,25,25,
            25,32,31,30,31,30
        };
    };
    public final static char scopeLhs[] = ScopeLhs.scopeLhs;
    public final int scopeLhs(int index) { return scopeLhs[index]; }

    public interface ScopeLa {
        public final static char scopeLa[] = {
            21,21,21,21,21,21,61,31,22,21,
            21,21,21,21,61,21,21,14,14,22,
            3,17,21,21,21,21,21,21,21,21,
            21,21,36,36,39,21,21,738,738,82,
            740,740,18,4,738,18,19,5,740,740,
            740,5,16,4,5,5
        };
    };
    public final static char scopeLa[] = ScopeLa.scopeLa;
    public final int scopeLa(int index) { return scopeLa[index]; }

    public interface ScopeStateSet {
        public final static char scopeStateSet[] = {
            23,124,111,55,111,13,55,23,111,111,
            111,9,9,111,55,112,23,16,16,111,
            55,127,121,32,23,4,46,127,1,55,
            112,23,29,43,55,111,111,111,111,138,
            111,111,111,111,18,111,111,111,111,111,
            111,111,111,111,111,111
        };
    };
    public final static char scopeStateSet[] = ScopeStateSet.scopeStateSet;
    public final int scopeStateSet(int index) { return scopeStateSet[index]; }

    public interface ScopeRhs {
        public final static char scopeRhs[] = {0,
            808,40,3,861,795,0,4,0,799,40,
            0,830,40,0,808,40,640,0,4,831,
            0,808,40,0,855,40,780,783,40,640,
            0,4,4,831,0,828,40,0,828,29,
            833,828,0,458,799,0,866,40,0,839,
            40,34,0,839,40,23,0,796,40,0,
            794,0,787,786,0,803,0,787,839,0,
            912,854,82,0,286,27,0,0,0,0,
            797,0,814,0,839,44,27,0,713,566,
            0,713,160,0,351,444,0,351,443,444,
            0,376,786,0,0,443,376,786,0,0,
            794,16,794,0,45,786,0,74,786,45,
            786,0,794,16,5,794,0,443,74,786,
            45,786,0,794,738,799,40,0,4,318,
            788,0,9,786,4,318,788,0,4,443,
            318,788,0,9,786,4,443,318,788,0,
            318,788,0,443,318,788,0,799,40,4,
            794,0,318,3,816,4,0,799,40,4,
            5,794,0,443,318,3,816,4,0,899,
            40,0,898,40,84,331,0,855,854,40,
            780,783,0,794,40,0,799,0,9,786,
            0,808,40,293,0,874,40,46,0,52,
            802,4,0,794,39,0,658,786,0,831,
            39,0,848,873,794,45,0,239,0,794,
            45,0,797,0,239,0,848,872,45,0,
            822,40,5,0,822,40,0,4,16,609,
            788,0,4,16,46,788,0,787,39,788,
            0,787,609,788,0,787,46,788,0
        };
    };
    public final static char scopeRhs[] = ScopeRhs.scopeRhs;
    public final int scopeRhs(int index) { return scopeRhs[index]; }

    public interface ScopeState {
        public final static char scopeState[] = {0,
            1177,1008,0,1444,1256,1231,807,0,1317,1177,
            827,1008,1087,807,0,876,0,1694,425,1197,
            373,0,1107,2160,869,2157,863,0,929,402,
            0,636,583,731,689,729,425,373,770,530,
            477,0,447,1516,0,1224,1167,1126,1122,1110,
            1066,1052,847,757,1317,1177,827,1765,1008,1134,
            1746,1444,1256,1231,1087,1715,1028,887,2113,807,
            973,1423,2097,2081,2065,2049,2033,1387,2017,1694,
            1840,1617,2001,1985,1969,1953,1197,1937,1824,1921,
            1872,1856,1590,1567,1471,1071,2143,2129,1792,1676,
            1371,1808,1548,1532,931,1516,1648,1408,1337,1500,
            770,636,583,731,689,425,373,530,477,0,
            1808,1500,0,914,2171,0,887,973,2160,1278,
            2190,2157,1710,448,1335,1274,0,827,1134,1746,
            1028,887,552,1423,1387,425,1197,373,1548,395,
            931,860,2167,0
        };
    };
    public final static char scopeState[] = ScopeState.scopeState;
    public final int scopeState(int index) { return scopeState[index]; }

    public interface InSymb {
        public final static char inSymb[] = {0,
            0,870,58,87,65,797,14,796,755,17,
            836,781,780,66,82,38,40,808,918,795,
            33,836,852,805,756,836,854,914,2,1,
            46,45,741,76,26,781,780,783,54,70,
            69,53,793,794,40,808,818,6,9,12,
            738,861,40,44,852,35,903,40,912,40,
            780,781,795,794,738,40,872,39,794,795,
            780,783,40,40,40,754,47,753,739,2,
            1,796,799,794,3,879,910,794,13,916,
            40,785,783,917,38,853,738,17,794,756,
            756,805,874,20,794,848,60,831,5,803,
            293,40,794,817,822,820,873,39,756,40,
            865,915,865,793,793,738,40,738,738,905,
            853,740,738,902,794,40,738,913,828,640,
            40,795,781,795,3,794,36,40,835,40,
            830,799,822,794,18,19,16,4,5,835,
            18,32,22,848,794,854,739,794,808,77,
            21,794,738,830,799,738,837,833,7,11,
            10,40,828,40,808,819,756,756,875,781,
            134,138,226,685,330,168,684,163,164,242,
            243,453,267,310,780,877,794,822,40,808,
            21,738,5,794,794,40,19,16,4,15,
            85,41,794,5,820,36,855,799,794,740,
            738,828,906,27,29,783,808,808,21,795,
            756,30,40,40,40,40,40,40,30,90,
            40,30,90,40,40,40,40,40,42,830,
            740,794,62,22,799,794,794,40,40,794,
            40,794,28,44,828,780,21,21,78,741,
            741,741,741,741,741,78,40,741,78,40,
            741,741,741,741,741,885,85,41,21,794,
            22,799,808,799,40,900,34,23,794,331,
            839,798,40,31,40,40,823,823,823,40,
            741,40,741,738,738,738,741,4,5,794,
            738,40,40,84,738,14,866,794,855,741,
            741,741,741,741,741,4,40,839,40,839,
            40,738,21,823,823,823,898,40,21,738,
            899,738
        };
    };
    public final static char inSymb[] = InSymb.inSymb;
    public final int inSymb(int index) { return inSymb[index]; }

    public interface Name {
        public final static String name[] = {
            "",
            "END-OF-COMMANDS",
            "Valid token",
            "(",
            ")",
            "\"",
            "'",
            "*",
            "+",
            ",",
            "-",
            ".",
            "/",
            ":",
            ";",
            "<",
            "=",
            ">",
            "?",
            "[",
            "]",
            "<>",
            ">=",
            "<=",
            "||",
            "..",
            "->",
            "table1, table2, table3, ...",
            "$empty",
            "ACCESS",
            "ACCTNG",
            "ACTION",
            "ACTIVATE",
            "ADD",
            "ADMIN",
            "ADMINISTRATION",
            "AFTER",
            "AGE",
            "ALIAS",
            "ALL",
            "ALLOCATE",
            "ALLOW",
            "ALTER",
            "ALTERIN",
            "ALWAYS",
            "AND",
            "ANY",
            "APPEND",
            "APPL_ID",
            "APPL_NAME",
            "APPLNAME",
            "ARRAY",
            "AS",
            "ASC",
            "ASCII",
            "ASENSITIVE",
            "ASSIGNMENT",
            "ASSOCIATE",
            "AST",
            "ASUTIME",
            "AT",
            "ATOMIC",
            "ATTRIBUTE",
            "ATTRIBUTES",
            "AUTHORIZATION",
            "AUTH_ID",
            "AUTHID",
            "AUTOMATIC",
            "AUTOSTART",
            "AVAILABLE",
            "B",
            "BEFORE",
            "BEGIN",
            "BERNOULLI",
            "BETWEEN",
            "BIGINT",
            "BINARY",
            "BIND",
            "BINDADD",
            "BIT",
            "BLOB",
            "BLOCKED",
            "BLOCKSIZE",
            "BOTH",
            "BUFFER",
            "BUFFERPOOL",
            "BUFFERPOOLS",
            "BUFFERSIZE",
            "BUILD",
            "BY",
            "BYPASS",
            "C",
            "CACHE",
            "CACHING",
            "CALL",
            "CALLED",
            "CALLER",
            "CAPTURE",
            "CARDINALITIES",
            "CARDINALITY",
            "CASCADE",
            "CASCADED",
            "CASE",
            "CAST",
            "CCSID",
            "CHANGE",
            "CHANGED",
            "CHANGES",
            "CHAR",
            "CHARACTER",
            "CHECK",
            "CHECKED",
            "CLIENT",
            "CLOB",
            "CLOSE",
            "CLR",
            "CLUSTER",
            "COBOL",
            "COLLECT",
            "COLLID",
            "COLUMN",
            "COLUMNS",
            "COMM",
            "COMMENT",
            "COMMIT",
            "COMMITTED",
            "COMPACT",
            "COMPARE",
            "COMPARISONS",
            "COMPRESS",
            "COMPRESSION",
            "CONCAT",
            "CONDITION",
            "CONN",
            "CONNECT",
            "CONNECTIONS",
            "CONNECTOPT",
            "CONNHEADER",
            "CONNMEMUSE",
            "CONSERVATIVE",
            "CONSTRAINT",
            "CONSTRAINTS",
            "CONSTRUCTOR",
            "CONTAINERS",
            "CONTAINS",
            "CONTENT",
            "CONTINUE",
            "CONTINUOUSLY",
            "CONTROL",
            "COPY",
            "COUNT",
            "COUNT_BIG",
            "CPU",
            "CREATE",
            "CREATE_EXTERNAL_ROUTINE",
            "CREATEIN",
            "CREATE_NOT_FENCED",
            "CREATE_NOT_FENCED_ROUTINE",
            "CREATETAB",
            "CS",
            "CUBE",
            "CURRENT",
            "CURRENT_DATE",
            "CURRENT_DEFAULT_TRANSFORM_GROU" +
            "P",
            "CURRENT_PATH",
            "CURRENT_ROLE",
            "CURRENT_TIME",
            "CURRENT_TIMESTAMP",
            "CURRENT_TRANSFORM_GROUP_FOR_TY" +
            "PE",
            "CURRENT_USER",
            "CURRVAL",
            "CURSOR",
            "CURSORS",
            "CYCLE",
            "DATA",
            "DATABASE",
            "DATALINK",
            "DATE",
            "DAY",
            "DAYS",
            "DB",
            "DBADM",
            "DBCLOB",
            "DBINFO",
            "DBMEMUSE",
            "DBPARTITIONNUM",
            "DBPARTITIONNUMS",
            "DB2DARI",
            "DB2GENRL",
            "DB2GENERAL",
            "DB2OPTIONS",
            "DB2SPL",
            "DB2SQL",
            "DB2_RETURN_STATUS",
            "DB2_TOKEN_STRING",
            "DEACTIVATE",
            "DEADLOCK",
            "DEADLOCKS",
            "DEC",
            "DECIMAL",
            "DECLARE",
            "DEFAULT",
            "DEFAULTS",
            "DEFINE",
            "DEFINITION",
            "DEGREE",
            "DEFER",
            "DEFERRED",
            "DELETE",
            "DESC",
            "DESCRIPTOR",
            "DETAILED",
            "DETAILS",
            "DETERMINED",
            "DETERMINISTIC",
            "DEVICE",
            "DIAGNOSTICS",
            "DIMENSIONS",
            "DIRTY",
            "DISABLE",
            "DISALLOW",
            "DISPATCH",
            "DISTINCT",
            "DISTRIBUTION",
            "DLCONN",
            "DLLOCK",
            "DO",
            "DOUBLE",
            "DROP",
            "DROPIN",
            "DROPPED",
            "DYNAMIC",
            "EACH",
            "ELEMENT",
            "ELSE",
            "ELSEIF",
            "EMPTY",
            "ENABLE",
            "ENCRYPTION",
            "END",
            "ENDING",
            "ENFORCED",
            "ERASE",
            "ESCAPE",
            "ESTIMATE",
            "EUR",
            "EVALUATE",
            "EVENT",
            "EXACT",
            "EXCEPT",
            "EXCEPTION",
            "EXCLUDE",
            "EXCLUDES",
            "EXCLUDING",
            "EXCLUSIVE",
            "EXECNODE",
            "EXECUTE",
            "EXISTS",
            "EXIT",
            "EXPAND",
            "EXPLAIN",
            "EXPRESSION",
            "EXTEND",
            "EXTENDED",
            "EXTENSION",
            "EXTENTSIZE",
            "EXTERNAL",
            "FALSE",
            "FEDERATED",
            "FEDERATED_TOOL",
            "FENCED",
            "FETCH",
            "FILE",
            "FILTER",
            "FINAL",
            "FIRST",
            "FLOAT",
            "FLUSH",
            "FOLLOWING",
            "FOR",
            "FORCE",
            "FOREIGN",
            "_FOREIGNKEY",
            "FOUND",
            "FREE",
            "FREEPAGE",
            "FROM",
            "FS",
            "FULL",
            "FUNCTION",
            "G",
            "GBPCACHE",
            "GENERAL",
            "GENERATE",
            "GENERATED",
            "GET",
            "GLOBAL",
            "GOTO",
            "GRANT",
            "GRAPHIC",
            "GROUP",
            "GROUPING",
            "HANDLER",
            "HASHING",
            "HAVING",
            "HIDDEN",
            "HIERARCHY",
            "HIGH",
            "HOLD",
            "HOUR",
            "HOURS",
            "HPJ",
            "ID",
            "IDENTITY",
            "IF",
            "IGNORE",
            "IMMEDIATE",
            "IMPLICIT_SCHEMA",
            "IN",
            "INCLUDE",
            "INCLUDES",
            "INCLUDING",
            "INCREMENT",
            "INCREMENTAL",
            "INDEX",
            "INDEXES",
            "INDICATOR",
            "INFIX",
            "INFO",
            "INHERIT",
            "INITIALLY",
            "INITIAL_INSTS",
            "INITIAL_IOS",
            "INLINE",
            "INNER",
            "INOUT",
            "INPUT",
            "INSENSITIVE",
            "INSERT",
            "INSTANTIABLE",
            "INSTEAD",
            "INSTS_PER_ARGBYTE",
            "INSTS_PER_INVOC",
            "INT",
            "INTEGER",
            "INTEGRITY",
            "INTERSECT",
            "INTO",
            "IO",
            "IOS_PER_ARGBYTE",
            "IOS_PER_INVOC",
            "IS",
            "ISO",
            "ITERATE",
            "ISOLATION",
            "JAVA",
            "JIS",
            "JOIN",
            "K",
            "KEEP",
            "KEY",
            "KEYS",
            "L",
            "LANGUAGE",
            "LARGE",
            "LAST",
            "LATERAL",
            "LC_CTYPE",
            "LEADING",
            "LEAVE",
            "LEFT",
            "LENGTH",
            "LEVEL",
            "LEVEL2",
            "LIBRARY",
            "LIBRARYADM",
            "LIKE",
            "LIMIT",
            "LINK",
            "LINKTYPE",
            "LOAD",
            "LOCAL",
            "LOCALE",
            "LOCALTIME",
            "LOCALTIMESTAMP",
            "LOCATOR",
            "LOCATORS",
            "LOCK",
            "LOCKS",
            "LOCKSIZE",
            "LOG",
            "LOGGED",
            "LONG",
            "LONGVAR",
            "LOOP",
            "LOW",
            "M",
            "MAIN_PROG",
            "MANAGED",
            "MANUALSTART",
            "MAPPING",
            "MATCHED",
            "MATERIALIZED",
            "MAXFILES",
            "MAXFILESIZE",
            "MAXVALUE",
            "MDC",
            "MERGE",
            "MESSAGE_TEXT",
            "METHOD",
            "METHODS",
            "MICROSECOND",
            "MICROSECONDS",
            "MINPCTUSED",
            "MINUTE",
            "MINUTES",
            "MINVALUE",
            "MIXED",
            "MODE",
            "MODIFIES",
            "MONITOR",
            "MONTH",
            "MONTHS",
            "MOVEMENT",
            "MULTISET",
            "N",
            "NAME",
            "NEW",
            "NEW_TABLE",
            "NEXT",
            "NEXTVAL",
            "NICKNAME",
            "NO",
            "NOCACHE",
            "NOCYCLE",
            "NODE",
            "NODES",
            "NODEGROUP",
            "NOMAXVALUE",
            "NOMINVALUE",
            "NONBLOCKED",
            "NONE",
            "NOORDER",
            "NOT",
            "NULL",
            "NULLS",
            "NUM",
            "NUMBLOCKPAGES",
            "NUMERIC",
            "NUM_FREQVALUES",
            "NUM_QUANTILES",
            "OBJECT",
            "OF",
            "OFF",
            "OLD",
            "OLD_TABLE",
            "OLE",
            "OLEDB",
            "ON",
            "ONCE",
            "ONLINE",
            "ONLY",
            "OPEN",
            "OPTIMIZATION",
            "OPTIMIZE",
            "OPTION",
            "OPTIONS",
            "OR",
            "ORDER",
            "ORGANIZE",
            "OUT",
            "OUTER",
            "OVER",
            "OVERFLOW",
            "OVERHEAD",
            "OVERRIDING",
            "P",
            "PACKAGE",
            "PAGE",
            "PAGESIZE",
            "PARALLEL",
            "PARAMETER",
            "PASSTHRU",
            "PASSWORD",
            "PATH",
            "PARTITION",
            "PARTITIONING",
            "PARTITIONINGS",
            "PATROLLER",
            "PCTDEACTIVATE",
            "PCTFREE",
            "PENDING",
            "PERCENT_ARGBYTES",
            "PERMISSION",
            "PIECESIZE",
            "PIPE",
            "PLAN",
            "PRECEDING",
            "PRECISION",
            "PREDICATES",
            "PREFETCHSIZE",
            "PREPARE",
            "PRESERVE",
            "PREVIOUS",
            "PREVVAL",
            "PRIMARY",
            "_PRIMARYKEY",
            "PRIQTY",
            "PRIVILEGES",
            "PROCEDURE",
            "PROFILE",
            "PROGRAM",
            "PROPAGATE",
            "PROTOCOL",
            "PRUNE",
            "PUBLIC",
            "QUERY",
            "QUERYNO",
            "QUERYTAG",
            "QUIESCE_CONNECT",
            "RANGE",
            "RATE",
            "RATIO",
            "READ",
            "READS",
            "REAL",
            "RECOMMEND",
            "RECONCILE",
            "RECOVERY",
            "RECREATE",
            "REDUCE",
            "REF",
            "REFERENCE",
            "REFERENCES",
            "REFERENCING",
            "REFRESH",
            "REGISTERS",
            "REGULAR",
            "RELEASE",
            "REMAIN",
            "REMOTE",
            "RENAME",
            "REOPT",
            "REPEATABLE",
            "REPEAT",
            "REPLACE",
            "REPLICATED",
            "REQUIRING",
            "RESET",
            "RESIDENT",
            "RESIGNAL",
            "RESIZE",
            "RESOLVE",
            "RESTART",
            "RESTORE",
            "RESTRICT",
            "RESULT",
            "RESULT_SET_LOCATOR",
            "RETAIN",
            "RETURN",
            "RETURNS",
            "RETURN_STATUS",
            "REVERSE",
            "REVOKE",
            "RIGHT",
            "ROLLBACK",
            "ROLLUP",
            "ROUTINE",
            "ROW",
            "ROW_COUNT",
            "ROWS",
            "RR",
            "RS",
            "RUN",
            "S",
            "SAMPLED",
            "SAVEPOINT",
            "SBCS",
            "SCANS",
            "SCHEMA",
            "SCOPE",
            "SCRATCHPAD",
            "SCROLL",
            "SEARCH",
            "SECOND",
            "SECONDS",
            "SECQTY",
            "SECURITYADM",
            "SELECT",
            "SELECTION",
            "SELECTIVE",
            "SELECTIVITY",
            "SELF",
            "SENSITIVE",
            "SEQUENCE",
            "SERIALIZABLE",
            "SERVER",
            "SESSION",
            "SESSION_USER",
            "SET",
            "SETS",
            "SETTING",
            "SHARE",
            "SHRLEVEL",
            "SIGNAL",
            "SIMPLE",
            "SIZE",
            "SMALLINT",
            "SNAPSHOT",
            "SOME",
            "SOURCE",
            "SPECIAL",
            "SPECIFIC",
            "SPECIFICATION",
            "SPLIT",
            "SQL",
            "SQLDATA",
            "SQLERROR",
            "SQLEXCEPTION",
            "SQLWARNING",
            "SQLID",
            "SQLMACRO",
            "SQLSTATE",
            "SSA",
            "STABILITY",
            "STAGING",
            "START",
            "STATE",
            "STATEMENT",
            "STATEMENTS",
            "STATIC",
            "STATISTICS",
            "STARTING",
            "STAY",
            "STMT",
            "STOGROUP",
            "STORAGE",
            "STORED",
            "STRIP",
            "STRIPE",
            "STYLE",
            "SUB",
            "SUBSECTION",
            "SUMMARY",
            "SWITCH",
            "SYMMETRIC",
            "SYNONYM",
            "SYSTEM",
            "SYSTEM_USER",
            "T",
            "TABLE",
            "TABLES",
            "TABLESAMPLE",
            "TABLESPACE",
            "TABLESPACES",
            "TARGET",
            "TEMPLATE",
            "TEMPORARY",
            "THEN",
            "THREADSAFE",
            "THROUGH",
            "TIME",
            "TIMEOUT",
            "TIMESTAMP",
            "TIMEZONE",
            "TO",
            "TOKEN",
            "TRAILING",
            "TRANSACTIONS",
            "TRANSFERRATE",
            "TRANSFORM",
            "TRANSFORMS",
            "TRANSLATE",
            "TREAT",
            "TRIGGER",
            "TRUE",
            "TRUNC",
            "TWOLEVEL",
            "TYPE",
            "TYPES",
            "UNBOUNDED",
            "UNCHECKED",
            "UNCOMMITTED",
            "UNDER",
            "UNDO",
            "UNICODE",
            "UNION",
            "UNIQUE",
            "UNLINK",
            "UNTIL",
            "UPDATE",
            "UR",
            "URL",
            "USA",
            "USE",
            "USAGE",
            "USER",
            "USERID",
            "USING",
            "VALUE",
            "VALUES",
            "VARCHAR",
            "VARGRAPHIC",
            "VARIANT",
            "VARYING",
            "VCAT",
            "VERSION",
            "VIEW",
            "VOLATILE",
            "WAIT",
            "WHEN",
            "WHERE",
            "WHILE",
            "WITH",
            "WITHOUT",
            "WORK",
            "WRAPPER",
            "WRITE",
            "WRKSTNNAME",
            "X",
            "XACT",
            "YEAR",
            "YEARS",
            "YES",
            "ABSENT",
            "ACCORDING",
            "BASE64",
            "DOCUMENT",
            "ENCODING",
            "HEX",
            "LOCATION",
            "NAMESPACE",
            "NIL",
            "ORDINALITY",
            "PASSING",
            "PI",
            "RETURNING",
            "URI",
            "WHITESPACE",
            "XML",
            "XMLAGG",
            "XMLATTRIBUTES",
            "XMLBINARY",
            "XMLCAST",
            "XMLCOMMENT",
            "XMLCONCAT",
            "XMLDECLARATION",
            "XMLDOCUMENT",
            "XMLELEMENT",
            "XMLEXISTS",
            "XMLFOREST",
            "XMLNAMESPACES",
            "XMLPARSE",
            "XMLPI",
            "XMLQUERY",
            "XMLSCHEMA",
            "XMLSERIALIZE",
            "XMLTABLE",
            "XMLTEXT",
            "XMLVALIDATE",
            "VERTICAL_BAR",
            "REGULAR_IDENTIFIER",
            "DELIMITED_IDENTIFIER",
            "EMBEDDED_VARIABLE_NAME",
            "UNSIGNED_INTEGER",
            "SUFFIXED_UNSIGNED_INTEGER",
            "EXACT_NUMERIC_LITERAL",
            "APPROXIMATE_NUMERIC_LITERAL",
            "NATIONAL_CHAR_STRING_LITERAL",
            "NATIONAL_HEX_STRING_LITERAL",
            "BIT_STRING_LITERAL",
            "HEX_STRING_LITERAL",
            "CHAR_STRING_LITERAL",
            "COMMENT_STRING",
            "DELIMITED_TYPE_IDENTIFIER",
            "VERSION_IDENTIFIER",
            "STATEMENT_TERMINATOR",
            "HOSTVARIABLE",
            "PARAMETER_MARKER",
            "LEFT_BRACKET_TRIGRAPH",
            "RIGHT_BRACKET_TRIGRAPH",
            "EOLN",
            "<sql_dml_stmt_list>",
            "<sql_dml_stmt_xspan>",
            "<alias_name>",
            "<identifier>",
            "<expression>",
            "<relop>",
            "<subquery>",
            "<as_alias>",
            "<boolean_expression>",
            "<boolean_term>",
            "<boolean_factor>",
            "<boolean_primary>",
            "<boolean_values>",
            "<simplecomp>",
            "<case_search_when_list>",
            "<case_simple_when_list>",
            "<case_search_when>",
            "<condition>",
            "<case_simple_when>",
            "<cast_operand>",
            "<cast_target>",
            "<datatype>",
            "<column>",
            "<column_name>",
            "<column_name_list>",
            "<column_ref>",
            "<table>",
            "<left_bracket_or_trigraph>",
            "<right_bracket_or_trigraph>",
            "<target_table>",
            "<target_column_list>",
            "<duration>",
            "<query_exp>",
            "<expression_term>",
            "<expression_commalist>",
            "<expression_factor>",
            "<grouping_exp>",
            "<grouping_sets_element_list>",
            "<grouping_sets_element>",
            "<grouping_sets_element_exp_lis" +
            "t>",
            "<grouping_sets_element_exp>",
            "<grouping_spec>",
            "<grouping_spec_list>",
            "<insert_row>",
            "<insert_row_commalist>",
            "<query_exp_root>",
            "<super_groups_element_list>",
            "<ordering_spec_commalist>",
            "<schema>",
            "<table_correlation>",
            "<ordering_spec>",
            "<path-resolved user-defined ty" +
            "pe name>",
            "<project>",
            "<query_combined_operator>",
            "<query_term>",
            "<selection>",
            "<values_row_commalist>",
            "<value_expr_row>",
            "<timestamp precision>",
            "<time precision>",
            "<super_groups_element_exp>",
            "<super_groups_element_exp_list" +
            ">",
            "<super_groups_element>",
            "<table_ref>",
            "<update_assignment_clause>",
            "<update_assignment_expression_" +
            "commalist>",
            "<update_assignment_expression>",
            "<values_row>",
            "<with_table_spec_list>",
            "<with_table_spec>"
        };
    };
    public final static String name[] = Name.name;
    public final String name(int index) { return name[index]; }

    public final static int
           ERROR_SYMBOL      = 779,
           SCOPE_UBOUND      = 55,
           SCOPE_SIZE        = 56,
           MAX_NAME_LENGTH   = 40;

    public final int getErrorSymbol() { return ERROR_SYMBOL; }
    public final int getScopeUbound() { return SCOPE_UBOUND; }
    public final int getScopeSize() { return SCOPE_SIZE; }
    public final int getMaxNameLength() { return MAX_NAME_LENGTH; }

    public final static int
           NUM_STATES        = 362,
           NT_OFFSET         = 779,
           LA_STATE_OFFSET   = 3142,
           MAX_LA            = 1,
           NUM_RULES         = 372,
           NUM_NONTERMINALS  = 145,
           NUM_SYMBOLS       = 924,
           SEGMENT_SIZE      = 8192,
           START_STATE       = 2167,
           IDENTIFIER_SYMBOL = 92,
           EOFT_SYMBOL       = 761,
           EOLT_SYMBOL       = 778,
           ACCEPT_ACTION     = 2312,
           ERROR_ACTION      = 2770;

    public final static boolean BACKTRACK = true;

    public final int getNumStates() { return NUM_STATES; }
    public final int getNtOffset() { return NT_OFFSET; }
    public final int getLaStateOffset() { return LA_STATE_OFFSET; }
    public final int getMaxLa() { return MAX_LA; }
    public final int getNumRules() { return NUM_RULES; }
    public final int getNumNonterminals() { return NUM_NONTERMINALS; }
    public final int getNumSymbols() { return NUM_SYMBOLS; }
    public final int getSegmentSize() { return SEGMENT_SIZE; }
    public final int getStartState() { return START_STATE; }
    public final int getStartSymbol() { return lhs[0]; }
    public final int getIdentifierSymbol() { return IDENTIFIER_SYMBOL; }
    public final int getEoftSymbol() { return EOFT_SYMBOL; }
    public final int getEoltSymbol() { return EOLT_SYMBOL; }
    public final int getAcceptAction() { return ACCEPT_ACTION; }
    public final int getErrorAction() { return ERROR_ACTION; }
    public final boolean isValidForParser() { return isValidForParser; }
    public final boolean getBacktrack() { return BACKTRACK; }

    public final int originalState(int state) {
        return -baseCheck[state];
    }
    public final int asi(int state) {
        return asb[originalState(state)];
    }
    public final int nasi(int state) {
        return nasb[originalState(state)];
    }
    public final int inSymbol(int state) {
        return inSymb[originalState(state)];
    }

    public final int ntAction(int state, int sym) {
        return baseAction[state + sym];
    }

    public final int tAction(int state, int sym) {
        if (sym == 0)
            return ERROR_ACTION;
        int i = baseAction[state],
            k = i + sym;
        if (termCheck[k] == sym)
            return termAction[k];
        i = termAction[i];
        return (shiftCheck[shiftState[i] + sym] == sym
                                ? defaultShift[sym]
                                : defaultReduce[i]);
    }
    public final int lookAhead(int la_state, int sym) {
        int k = la_state + sym;
        if (termCheck[k] == sym)
            return termAction[k];
        int i = termAction[la_state];
        return (shiftCheck[shiftState[i] + sym] == sym
                                ? defaultShift[sym]
                                : defaultReduce[i]);
    }
}
